package pse.client;

import java.io.*;

/**
 * Rappresenta una coppia valore-attributo all'interno di un ProfileSection
 */
public class ProfileAttributeJ2ME {

  /**
   * Nome dell'attributo
   */
  private String name = null;
  /**
   * valore dell'attributo
   */
  private String value = null;

  /*
  //UTILE ????
  public ProfileAttribute() {
  }*/

  /**
   * Costruttore
   * @param name il nome dell'attributo
   * @param value il valore dell'attributo
   */
  public ProfileAttributeJ2ME(String name, String value) {
    this.name = name;
    this.value = value;
  }

  /**
   * Costruttore. Il valore dell'attributo in questo caso  posto a null
   * @param name il nome dell'attributo
   */
  public ProfileAttributeJ2ME(String name) {
    this.name = name;
  }

  /**
   * Test di attributo vuoto
   * @return true se il valore dell'attributo  posto a null
   */
  public boolean isNull() {
    return (value == null);
  }

  /**
   * Restituisce il valore dell'attributo
   * @return il valore dell'attributo (potrebbe anche essere null)
   */
  public String getValue() {
    return value;
  }

  /**
   * Restituisce il nome dell'attributo
   * @return name
   */
  public String getName() {
    return name;
  }

  /**
   * Setta il valore dell'attributo
   * @param value il valore dell'attributo
   */
  public void setValue(String value) {
    this.value = value;
  }

  /**
   * Setta il nome dell'attributo
   * @param name il nome dell'attributo
   */
  public void setName(String name) {
    this.name = name;
  }

  public String toString() {
    return "("+name+"="+value+")";
  }

  public static void writeToStream(ProfileAttributeJ2ME attr, DataOutputStream stream) throws IOException {
    stream.writeUTF(attr.getName());
    stream.writeUTF(attr.getValue());
  }

  public static ProfileAttributeJ2ME readFromStream(DataInputStream stream) throws IOException {
    String n = stream.readUTF();
    String v = stream.readUTF();
    return new ProfileAttributeJ2ME(n, v);
  }

}