package pse.client;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.*;

public final class WrapperProfileJ2ME extends ProfileSectionJ2ME {

  private int index;
  private String serviceInterface;

  public WrapperProfileJ2ME(String serviceInterface, int index) {
    super("WrapperProfile("+serviceInterface+") : "+index);
    this.serviceInterface = serviceInterface;
    this.index = index;
  }

  public WrapperProfileJ2ME(String serviceInterface) {
    super("WrapperProfile("+serviceInterface+")");
    this.serviceInterface = serviceInterface;
    this.index = 0;
  }

  public void setServiceInterface(String serviceInterface) {
    this.serviceInterface = serviceInterface;
    super.setName("WrapperProfile("+serviceInterface+") : "+index);
  }

  public String getServiceInterface() {
    return serviceInterface;
  }

  public void setWrapperIndex(int index) {
    this.index = index;
    super.setName("WrapperProfile("+serviceInterface+") : "+index);
  }

  public int getWrapperIndex() {
    return index;
  }

  private WrapperProfileJ2ME(ProfileSectionJ2ME copy, String serviceInterface, int index) {
    this(serviceInterface, index);
    addAttributeList(copy.getAttributeList());
    addSectionList(copy.getSectionList());
  }

  public static void writeToStream(WrapperProfileJ2ME sec, DataOutputStream stream) throws IOException {
    //Scrivo l'interfaccia del servizio
    stream.writeUTF(sec.getServiceInterface());
    //Scrivo l'indice del wrapper
    stream.writeInt(sec.getWrapperIndex());
    ProfileSectionJ2ME.writeToStream((ProfileSectionJ2ME)sec, stream);
  }

  public static ProfileSectionJ2ME readFromStream(DataInputStream stream) throws IOException {
    //Leggo l'interfaccia del servizio
    String si = stream.readUTF();
    //LEggo l'indice del Wrapper
    int wi = stream.readInt();
    ProfileSectionJ2ME copy = ProfileSectionJ2ME.readFromStream(stream);
    return new WrapperProfileJ2ME(copy, si, wi);
  }

}