package pse.client.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

//import java.net.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;

import com.sun.midp.io.InternalConnector;

import java.io.*;
import pse.shared.*;
import pse.client.*;

public class DeviceMessenger {

  DeviceMessengerListener listener;
  //Socket callSocket;
  StreamConnection callSocket;
  //Socket responseSocket;
  StreamConnection responseSocket;
  /*
  ObjectOutputStream callOutput;
  ObjectInputStream callInput;
  ObjectOutputStream responseOutput;
  ObjectInputStream responseInput;
  */
  DataOutputStream callOutput;
  DataInputStream callInput;
  DataOutputStream responseOutput;
  DataInputStream responseInput;
  ListeningThread listeningThread;

  //public DeviceMessenger(DeviceMessengerListener listener, Socket callSocket, Socket responseSocket) {
  public DeviceMessenger(DeviceMessengerListener listener, StreamConnection callSocket, StreamConnection responseSocket) {
    this.listener = listener;
    this.callSocket = callSocket;
    this.responseSocket = responseSocket;
    try {
      //System.out.println("DeviceMessenger - 5");
      //callOutput = new ObjectOutputStream(callSocket.getOutputStream());
      //callOutput = new DataOutputStream(callSocket.getOutputStream());
      callOutput = callSocket.openDataOutputStream();
      //System.out.println("DeviceMessenger - 6");
      //callInput = new ObjectInputStream(callSocket.getInputStream());
      //callInput = new DataInputStream(callSocket.getInputStream());
      callInput = callSocket.openDataInputStream();
      //System.out.println("DeviceMessenger - 7");
      //responseOutput = new ObjectOutputStream(responseSocket.getOutputStream());
      //responseOutput = new DataOutputStream(responseSocket.getOutputStream());
      responseOutput = responseSocket.openDataOutputStream();
      //System.out.println("DeviceMessenger - 8");
      //responseInput = new ObjectInputStream(responseSocket.getInputStream());
      //responseInput = new DataInputStream(responseSocket.getInputStream());
      responseInput = responseSocket.openDataInputStream();
      //System.out.println("DeviceMessenger - 9");
    }
    catch (IOException e) {
      System.out.println("Errore nella creazione degli stream: "+e.getMessage());
    }
    listeningThread = new ListeningThread();
    listeningThread.start();
  }

  public synchronized void findFramework() throws PSEException {
    try {
      callOutput.writeInt(PSEMessage.FIND_FRAMEWORK);
      callOutput.flush();
    }
    catch (IOException ex) {
      throw new PSEException(ex.getMessage());
    }
    return; //Cos  non bloccante
  }

  public synchronized void login(String un, String pwd, DeviceProfileJ2ME dp) throws PSEException {
    try {
      callOutput.writeInt(PSEMessage.LOGIN);
      //callOutput.writeObject(un);
      callOutput.writeUTF(un);
      //callOutput.writeObject(pwd);
      callOutput.writeUTF(pwd);
      //callOutput.writeObject(dp);
      DeviceProfileJ2ME.writeToStream(dp, callOutput);
      System.out.println("login -1");
      callOutput.flush();
      System.out.println("login -2");
      int res = callInput.readInt();
      System.out.println("login -3");
      switch (res) {
        case PSEMessage.LOGIN_SUCCESS:
          System.out.println("login -4");
          //SessionID sID = (SessionID)callInput.readObject();
          System.out.println("login -5");
          //return sID;
          return;
        case PSEMessage.LOGIN_FAILURE:
          System.out.println("login -6");
        case PSEMessage.ERROR :
          System.out.println("login -7");
        default :
          throw new PSEException("Login Failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("Login Failed "+ex.getMessage());
    }
  }

  public synchronized void logout() throws PSEException {
    try {
      System.out.println("DeviceMessenger.logout - 1");
      callOutput.writeInt(PSEMessage.LOGOUT);
      System.out.println("DeviceMessenger.logout - 2");
      callOutput.flush();
      System.out.println("DeviceMessenger.logout - 2,5");
      int res = callInput.readInt();
      System.out.println("DeviceMessenger.logout - 3");
      switch (res) {
        case PSEMessage.LOGOUT_SUCCESS:
          return;
        case PSEMessage.LOGOUT_FAILURE:
        case PSEMessage.ERROR :
        default :
          throw new PSEException("Logout Failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("Logout Failed");
    }
  }

  public synchronized FoundServicesProfiles findServices(int bridgeIndex, String serviceInterface, int wrapperIndex,
            WrapperProfileJ2ME wrapperProfile, String bridgeName) throws PSEException {
    try {
      callOutput.writeInt(PSEMessage.FIND_SERVICES_1);
      callOutput.writeInt(bridgeIndex);
      //callOutput.writeObject(serviceInterface);
      callOutput.writeUTF(serviceInterface);
      callOutput.writeInt(wrapperIndex);
      //callOutput.writeObject(wrapperProfile);
      WrapperProfileJ2ME.writeToStream(wrapperProfile, callOutput);
      //callOutput.writeObject(bridgeName);
      callOutput.writeUTF(bridgeName);
      callOutput.flush();
      int res = callInput.readInt();
      System.out.println("DeviceMessenger.findService()v.1 Ho ottenuto : "+res);
      switch (res) {
        case PSEMessage.FIND_SERVICES_SUCCESS:
          //FoundServicesProfiles fsp = (FoundServicesProfiles)callInput.readObject();
          System.out.println("DeviceMessenger.findService()v.1 - 1");
          FoundServicesProfiles fsp = (FoundServicesProfiles)FoundServicesProfiles.readFromStream(callInput);
          System.out.println("DeviceMessenger.findService()v.1 - 2");
          return fsp;
        case PSEMessage.FIND_SERVICES_FAILURE:
        case PSEMessage.ERROR:
        default:
          throw new PSEException("FindServices() failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("FindServices() failed");
    }
  }

  public synchronized FoundServicesProfiles findServices(int bridgeIndex) throws PSEException {
    try {
      callOutput.writeInt(PSEMessage.FIND_SERVICES_2);
      callOutput.writeInt(bridgeIndex);
      callOutput.flush();
      int res = callInput.readInt();
      //System.out.println("DeviceMessenger.findService()v.1 Ho ottenuto : "+res);
      switch (res) {
        case PSEMessage.FIND_SERVICES_SUCCESS:
          //FoundServicesProfiles fsp = (FoundServicesProfiles)callInput.readObject();
          FoundServicesProfiles fsp = (FoundServicesProfiles)FoundServicesProfiles.readFromStream(callInput);
          return fsp;
        case PSEMessage.FIND_SERVICES_FAILURE:
        case PSEMessage.ERROR:
        default:
          throw new PSEException("FindServices() failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("FindServices() failed");
    }
  }

  public synchronized int startBridge(int bridgeIndex, int proxyIndex) throws PSEException {
    try {
      callOutput.writeInt(PSEMessage.START_BRIDGE);
      callOutput.writeInt(bridgeIndex);
      callOutput.writeInt(proxyIndex);
      callOutput.flush();
      int res = callInput.readInt();
      //System.out.println("DeviceMessenger.findService()v.1 Ho ottenuto : "+res);
      switch (res) {
        case PSEMessage.START_BRIDGE_SUCCESS:
          int brPort = callInput.readInt();
          return brPort;
        case PSEMessage.START_BRIDGE_FAILURE:
        case PSEMessage.ERROR:
        default:
          throw new PSEException("startBridge() failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("startBridge() failed");
    }
  }

  public synchronized void stopBridge(int bridgeIndex) throws PSEException {
    System.out.println("stopBridge()");
    //Per ora lo implemento sincrono, anche se in realt potrebbe essere benissiom asincrono
    try {
      callOutput.writeInt(PSEMessage.STOP_BRIDGE);
      callOutput.writeInt(bridgeIndex);
      callOutput.flush();
      int res = callInput.readInt();
      //System.out.println("DeviceMessenger.findService()v.1 Ho ottenuto : "+res);
      switch (res) {
        case PSEMessage.STOP_BRIDGE_SUCCESS:
          System.out.println("STOP_BRIDGE_SUCCESS");
          return;
        case PSEMessage.STOP_BRIDGE_FAILURE:
          System.out.println("STOP_BRIDGE_FAILURE");
        case PSEMessage.ERROR:
          System.out.println("ERROR");
        default:
          System.out.println("default "+res);
          throw new PSEException("stopBridge() failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("stopBridge() failed");
    }
  }

  //Anche questo lo si potrebbe fare tranquillamente sincrono
  public synchronized void startedService(int bridgeIndex) throws PSEException {
    try {
      callOutput.writeInt(PSEMessage.STARTED_SERVICE);
      callOutput.writeInt(bridgeIndex);
      callOutput.flush();
      int res = callInput.readInt();
      //System.out.println("DeviceMessenger.findService()v.1 Ho ottenuto : "+res);
      switch (res) {
        case PSEMessage.STARTED_SERVICE_SUCCESS:
          return;
        case PSEMessage.STARTED_SERVICE_FAILURE:
        case PSEMessage.ERROR:
        default:
          throw new PSEException("startedServices() failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("startedServices() failed "+ex.getMessage());
    }
  }

  //Anche questo lo si potrebbe fare tranquillamente sincrono
  public synchronized void stoppedService(int bridgeIndex) throws PSEException {
    System.out.println("Sono DeviceMessenger.stoppedService(");
    try {
      callOutput.writeInt(PSEMessage.STOPPED_SERVICE);
      callOutput.writeInt(bridgeIndex);
      callOutput.flush();
      int res = callInput.readInt();
      //System.out.println("DeviceMessenger.findService()v.1 Ho ottenuto : "+res);
      switch (res) {
        case PSEMessage.STOPPED_SERVICE_SUCCESS:
          System.out.println("STOPPED_SERVICE_SUCCESS");
          return;
        case PSEMessage.STOPPED_SERVICE_FAILURE:
          System.out.println("STOPPED_SERVICE_FAILURE");
        case PSEMessage.ERROR:
          System.out.println("ERROR");
        default:
          System.out.println("default");
          throw new PSEException("stoppedService() failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("stoppedService() failed");
    }
  }

  public synchronized UserProfileJ2ME getUserProfile() throws PSEException {
    System.out.println("Sono DeviceMessenger.getUserProfile()");
    try {
      callOutput.writeInt(PSEMessage.GET_USER_PROFILE);
      callOutput.flush();
      int res = callInput.readInt();
      //System.out.println("DeviceMessenger.findService()v.1 Ho ottenuto : "+res);
      switch (res) {
        case PSEMessage.GET_USER_PROFILE_SUCCESS:
          System.out.println("GET_USER_PROFILE_SUCCESS");
          //UserProfileJ2ME up = (UserProfileJ2ME)callInput.readObject();
          UserProfileJ2ME up = (UserProfileJ2ME)UserProfileJ2ME.readFromStream(callInput);
          return up;
        case PSEMessage.GET_USER_PROFILE_FAILURE:
          System.out.println("STOPPED_SERVICE_FAILURE");
        case PSEMessage.ERROR:
          System.out.println("ERROR");
        default:
          System.out.println("default");
          throw new PSEException("getUserProfile() failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("getUserProfile() failed");
    }
  }

  public synchronized void setUserProfile(UserProfileJ2ME userProfile) throws PSEException {
    System.out.println("Sono DeviceMessenger.setUserProfile()");
    try {
      callOutput.writeInt(PSEMessage.SET_USER_PROFILE);
      //callOutput.writeObject(userProfile);
      UserProfileJ2ME.writeToStream(userProfile, callOutput);
      callOutput.flush();
      int res = callInput.readInt();
      //System.out.println("DeviceMessenger.findService()v.1 Ho ottenuto : "+res);
      switch (res) {
        case PSEMessage.SET_USER_PROFILE_SUCCESS:
          System.out.println("SET_USER_PROFILE_SUCCESS");
          return;
        case PSEMessage.SET_USER_PROFILE_FAILURE:
          System.out.println("SET_USER_PROFILE_FAILURE");
        case PSEMessage.ERROR:
          System.out.println("ERROR");
        default:
          System.out.println("default");
          throw new PSEException("setUserProfile() failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("setUserProfile() failed");
    }
  }

  public synchronized ServicePreferencesJ2ME getServicePreferences(String serviceInterface) throws PSEException {
    System.out.println("Sono DeviceMessenger.getServicePreferences()");
    try {
      callOutput.writeInt(PSEMessage.GET_SERVICE_PREFERENCES);
      //callOutput.writeObject(serviceInterface);
      callOutput.writeUTF(serviceInterface);
      callOutput.flush();
      int res = callInput.readInt();
      //System.out.println("DeviceMessenger.findService()v.1 Ho ottenuto : "+res);
      switch (res) {
        case PSEMessage.GET_SERVICE_PREFERENCES_SUCCESS:
          System.out.println("GET_SERVICE_PREFERENCES_SUCCESS");
          //ServicePreferencesJ2ME sp = (ServicePreferencesJ2ME)callInput.readObject();
          ServicePreferencesJ2ME sp = (ServicePreferencesJ2ME)ServicePreferencesJ2ME.readFromStream(callInput);
          return sp;
        case PSEMessage.GET_SERVICE_PREFERENCES_FAILURE:
          System.out.println("GET_SERVICE_PREFERENCES_FAILURE");
        case PSEMessage.ERROR:
          System.out.println("ERROR");
        default:
          System.out.println("default");
          throw new PSEException("getServicePreferences() failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("getServicePreferences() failed");
    }
  }

  public synchronized void setServicePreferences(ServicePreferencesJ2ME servicePreferences) throws PSEException {
    System.out.println("Sono DeviceMessenger.setServicePreferences()");
    try {
      callOutput.writeInt(PSEMessage.SET_SERVICE_PREFERENCES);
      //callOutput.writeObject(servicePreferences);
      ServicePreferencesJ2ME.writeToStream(servicePreferences, callOutput);
      callOutput.flush();
      int res = callInput.readInt();
      //System.out.println("DeviceMessenger.findService()v.1 Ho ottenuto : "+res);
      switch (res) {
        case PSEMessage.SET_SERVICE_PREFERENCES_SUCCESS:
          System.out.println("SET_SERVICE_PREFERENCES_SUCCESS");
          return;
        case PSEMessage.SET_SERVICE_PREFERENCES_FAILURE:
          System.out.println("SET_SERVICE_PREFERENCES_FAILURE");
        case PSEMessage.ERROR:
          System.out.println("ERROR");
        default:
          System.out.println("default");
          throw new PSEException("setServicePreferences() failed");
      }
    }
    catch (Exception ex) {
      throw new PSEException("setServicePreferences() failed");
    }
  }

  public void deviceAlive() throws PSEException{
    System.out.println("DeviceMessenger.deviceAlive()");
    try {
      callOutput.writeInt(PSEMessage.DEVICE_ALIVE);
      callOutput.flush();
    }
    catch (IOException ex) {
      throw new PSEException(ex.getMessage());
    }
    return; //Cos  non bloccante
  }

  public void destroy() {
    if (callOutput != null) {
      try {
        callOutput.close();
      }
      catch (IOException ex) {
      }
    }
    if (callInput != null) {
      try {
        callInput.close();
      }
      catch (IOException ex) {
      }
    }
    if (responseOutput != null) {
      try {
        responseOutput.close();
      }
      catch (IOException ex) {
      }
    }
    if (responseInput != null) {
      try {
        responseInput.close();
      }
      catch (IOException ex) {
      }
    }
  }

  class ListeningThread extends Thread {
    ListeningThread() {
    }
    public void run() {
      int msgType;
      //Questo qui non fa altro che sospendersi sulla socket di ascolto, ed inoltrare le richieste al listener
      while (true) {
        try {
          msgType = responseInput.readInt();
        }
        catch (IOException ex) {
          System.out.println("Errore in ricezione: "+ex.getMessage());
          break;
          //Fare qlcs di meglio
        }
        switch (msgType) {
          case PSEMessage.FOUND_FRAMEWORK:
                    listener.foundFramework();
                    //E' non bloccante. Non devo tornare nulla
                    break;
          case PSEMessage.KEEP_ALIVE:
                    long period = 0;
                    try {
                      System.out.println("PSEMessage.KEEP_ALIVE -1");
                      period = responseInput.readLong();
                    }
                    catch (Exception ex) {
                      //Nessuna azione. Non gli arriver l'ok
                    }
                    listener.keepAlive(period);
                    break;
          default: System.out.println("Messaggio non riconosciuto");
        }
      }
    }
  }

}