package pse.client.framework;

import javax.microedition.lcdui.*;
import pse.client.*;

public class ExecutingWrapperInfoScreen extends Form implements ProfileSectionViewerListener, FoundServicesScreenListener {

  DeviceClient midlet;
  UIListener listener;
  String wrapperName;
  String serviceInterface;
  WrapperProfileJ2ME profile;
  int state;
  FoundServicesProfiles foundServicesProfiles;
  /** indice del proxy che si sta utilizzando */
  int proxyUsed;

  Command commandBack;
  Command commandUse;
  Command commandProfile;
  Command commandProxies;
  StringItem stringItem1 = new StringItem("", "");
  StringItem serviceNameTF = new StringItem("", "");
  StringItem stringItem3 = new StringItem("", "");
  StringItem serviceInterfaceTF = new StringItem("", "");
  StringItem stringItem2 = new StringItem("", "");
  StringItem stateTF = new StringItem("", "");
  StringItem stringItem4 = new StringItem("", "");
  StringItem usedProxyTF = new StringItem("", "");

  /**Construct the displayable*/
  public ExecutingWrapperInfoScreen(DeviceClient midlet, UIListener listener,
        String wrapperName, String serviceInterface, WrapperProfileJ2ME profile,
        int state, FoundServicesProfiles foundServicesProfiles, int proxyUsed) {
    super("Service Info");
    this.midlet = midlet;
    this.listener = listener;
    this.wrapperName = wrapperName;
    this.serviceInterface = serviceInterface;
    this.profile = profile;
    this.state = state;
    this.foundServicesProfiles = foundServicesProfiles;
    this.proxyUsed = proxyUsed;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    commandBack = new Command("Back", Command.BACK, 1);
    commandUse = new Command("Use", Command.SCREEN, 2);
    commandProfile = new Command("Profile", Command.SCREEN, 1);
    commandProxies = new Command("Proxies", Command.SCREEN, 2);
    stringItem4.setLabel("Index of used proxy:");
    stringItem2.setLabel("State:\n");
    //stringItem3.setText("Service Interface:\n");
    //stringItem1.setText("Service Name:\n");
    //serviceInterfaceTF.setText(serviceInterface+"\n");
    //serviceNameTF.setText(wrapperName+"\n");
    stringItem3.setLabel("Service Interface:\n");
    stringItem1.setLabel("Service Name:\n");
    serviceInterfaceTF.setLabel(serviceInterface+"\n");
    serviceNameTF.setLabel(wrapperName+"\n");
    usedProxyTF.setLabel(proxyUsed+"");
    stateTF.setLabel(ServiceDescriptor.getStateAsString(state));
    addCommand(commandBack);
    addCommand(commandUse);
    addCommand(commandProfile);
    addCommand(commandProxies);
    this.append(stringItem1);
    this.append(serviceNameTF);
    this.append(stringItem3);
    this.append(serviceInterfaceTF);
    this.append(stringItem2);
    this.append(stateTF);
    this.append(stringItem4);
    this.append(usedProxyTF);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==commandBack) {
      listener.doBackFromWrapperInfo();
    }
    else if (c==commandUse) {
      listener.doUseService(wrapperName);
    }
    else if (c==commandProfile) {
      ProfileSectionViewer profView = new ProfileSectionViewer(midlet, this, profile, "");
      Display.getDisplay(midlet).setCurrent(profView);
    }
    else if (c==commandProxies) {
      FoundServicesViewer fsViewer = new FoundServicesViewer(midlet, this, foundServicesProfiles);
      Display.getDisplay(midlet).setCurrent(fsViewer);
    }
  }

  public void backCommandFromViewer() {
    Display.getDisplay(midlet).setCurrent(this);
  }

  public void doBackFromFSScreen() {
    Display.getDisplay(midlet).setCurrent(this);
  }

  public void selectedProxy(int proxyIndex) {
    //Non si pu selezionare da qui
  }

}