package pse.client.framework;

import javax.microedition.lcdui.*;
import pse.client.ServerProfileJ2ME;

public class FoundServiceChooser extends Form implements ProfileSectionViewerListener  {

  DeviceClient midlet;
  FoundServicesProfiles fsProfiles;
  FoundServicesScreenListener listener;

  Command commandBack;
  Command commandProfile;

  ChoiceGroup proxiesCG = new ChoiceGroup("", 1);

  /**Construct the displayable*/
  public FoundServiceChooser(DeviceClient midlet, FoundServicesScreenListener listener, FoundServicesProfiles fsProfiles) {
    super("Choose a Proxy to use");
    this.midlet = midlet;
    this.listener = listener;
    this.fsProfiles = fsProfiles;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    setItemStateListener(new ItemStateListener()  {
      public void itemStateChanged(Item item) {
        this_itemStateChanged(item);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    this.append(proxiesCG);
    commandBack = new Command("Back", Command.BACK, 1);
    commandProfile = new Command("Profile", Command.SCREEN, 1);
    addCommand(commandBack);
    addCommand(commandProfile);
    int sn = fsProfiles.getNumberOfServices();
    for (int i=0; i<sn; i++) {
      proxiesCG.append("Proxy "+i, null);
    }
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==commandBack) {
      listener.doBackFromFSScreen();
    }
    else if (c==commandProfile) {
      int si = proxiesCG.getSelectedIndex();
      if (si!=-1) {
        ServerProfileJ2ME sp = fsProfiles.getServerProfile(si);
        ProfileSectionViewer profView = new ProfileSectionViewer(midlet, this, sp, "");
        Display.getDisplay(midlet).setCurrent(profView);
      }
    }
  }

  public void this_itemStateChanged(Item item) {
    System.out.println("Invocato itemStateChanged con item = "+item);
    if (item == proxiesCG) {
      int spi = proxiesCG.getSelectedIndex();
      if (spi!=-1) {
        listener.selectedProxy(spi);
      }
    }
  }

  public void backCommandFromViewer() {
    Display.getDisplay(midlet).setCurrent(this);
  }
}