package pse.client.framework;

import javax.microedition.lcdui.*;
import pse.client.ServerProfileJ2ME;

public class FoundServicesViewer extends List implements ProfileSectionViewerListener {

  DeviceClient midlet;
  FoundServicesProfiles fsProfiles;
  FoundServicesScreenListener listener;

  Command commandBack;
  Command commandProfile;


  /**Construct the displayable*/
  public FoundServicesViewer(DeviceClient midlet, FoundServicesScreenListener listener, FoundServicesProfiles fsProfiles) {
    super("Displayable Title", List.IMPLICIT);
    this.midlet = midlet;
    this.listener = listener;
    this.fsProfiles = fsProfiles;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    commandBack = new Command("Back", Command.BACK, 1);
    commandProfile = new Command("Profile", Command.SCREEN, 1);
    addCommand(commandBack);
    addCommand(commandProfile);
    int sn = fsProfiles.getNumberOfServices();
    for (int i=0; i<sn; i++) {
      append("Proxy "+i, null);
    }
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==commandBack) {
      listener.doBackFromFSScreen();
    }
    else if (c==commandProfile) {
      int si = getSelectedIndex();
      if (si!=-1) {
        ServerProfileJ2ME sp = fsProfiles.getServerProfile(si);
        ProfileSectionViewer profView = new ProfileSectionViewer(midlet, this, sp, "");
        Display.getDisplay(midlet).setCurrent(profView);
      }
    }
  }

  public void backCommandFromViewer() {
    Display.getDisplay(midlet).setCurrent(this);
  }
}