package pse.client.framework;

import javax.microedition.lcdui.*;
import java.util.Enumeration;

public class InitialScreen extends List {

  UIListener listener;
  Enumeration enWrappers;
  Command commandExit;
  Command commandSearchFramework;

  /**Construct the displayable*/
  public InitialScreen(UIListener l, Enumeration serviceNames) {
    super("Installed services:", List.IMPLICIT);
    listener = l;
    enWrappers = serviceNames;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    while (enWrappers.hasMoreElements()) {
      String currServName = (String)enWrappers.nextElement();
      append(currServName, null);
    }
    commandExit = new Command("Exit", Command.EXIT, 1);
    commandSearchFramework = new Command("Search PSE Fr.", Command.SCREEN, 1);
    addCommand(commandExit);
    addCommand(commandSearchFramework);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==List.SELECT_COMMAND) {
      int selWrapperIndex = getSelectedIndex();
      if (selWrapperIndex!=-1) {
        String selWrapper = getString(selWrapperIndex);
        listener.doViewWrapperInfo(selWrapper);
      }
    }
    else if (c==commandExit) {
      System.out.println("Selezionato Exit");
      listener.doExitAtInitial();
    }
    else if (c==commandSearchFramework) {
      System.out.println("Selezionato Search Framework");
      listener.doSearchFramework();
    }
  }
}