package pse.client.framework;

import javax.microedition.lcdui.*;
import java.util.Enumeration;

public class MainScreen extends List {

  UIListener listener;
  Enumeration enWrappers;
  Command commandChangeProfile;
  Command commandLogout;
  Command commandInfo;


  /**Construct the displayable*/
  public MainScreen(UIListener l, Enumeration serviceNames) {
    super("Installed Services:", List.IMPLICIT);
    listener = l;
    enWrappers = serviceNames;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    System.out.println("MainScreen.jbInit()");
    while (enWrappers.hasMoreElements()) {
      String currServName = (String)enWrappers.nextElement();
      append(currServName, null);
    }
    commandLogout = new Command("Logout", Command.SCREEN, 2);
    commandChangeProfile = new Command("Profile", Command.SCREEN, 2);
    commandInfo = new Command("Info", Command.SCREEN, 1);
    addCommand(commandLogout);
    addCommand(commandChangeProfile);
    addCommand(commandInfo);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==List.SELECT_COMMAND) {
      int selWrapperIndex = getSelectedIndex();
      if (selWrapperIndex!=-1) {
        String selWrapper = getString(selWrapperIndex);
        listener.doHandleService(selWrapper);
      }
    }
    else if (c==commandLogout) {
      listener.doLogout();
    }
    else if (c==commandChangeProfile) {
      int selWrapperIndex = getSelectedIndex();
      if (selWrapperIndex!=-1) {
        String selWrapper = getString(selWrapperIndex);
        listener.doChangeProfile(selWrapper);
      }
      else listener.doChangeProfile(null);
    }
    else if (c==commandInfo) {
      int selWrapperIndex = getSelectedIndex();
      if (selWrapperIndex!=-1) {
        String selWrapper = getString(selWrapperIndex);
        listener.doViewActiveWrapperInfo(selWrapper);
      }
    }
  }
}