package pse.client.framework;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

import pse.client.*;

public class ProfileSectionSelector extends List implements ProfileSectionViewerListener {

  ProfileSectionViewer backViewer;
  ProfileSectionViewer frontViewer;
  ProfileSectionJ2ME [] sections;
  MIDlet midlet;
  String containers; //Indicazione delle sezioni che contengono ad albero questa. Es: p1/p2)

  Command commandBack;
  Command commandSelect;

  /**Construct the displayable*/
  public ProfileSectionSelector(MIDlet mid, ProfileSectionViewer viewer, ProfileSectionJ2ME[] psl, String containers) {
    super("Choose a Section", List.IMPLICIT);
    midlet = mid;
    backViewer = viewer;
    sections = psl;
    this.containers = containers;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    commandBack = new Command("Back", Command.BACK, 1);
    addCommand(commandBack);
    commandSelect = new Command("Select", Command.SCREEN, 1);
    addCommand(commandSelect);
    for (int i=0; i<sections.length; i++) {
      append(sections[i].getName(), null);
    }
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    // add your command event handling here
    if (c==commandBack) {
      backViewer.backCommandFromSelector();
    }
    else if (c==commandSelect) {
      int si = getSelectedIndex();
      if (si!=-1) {
        frontViewer = new ProfileSectionViewer(midlet, this, sections[si], containers);
        Display.getDisplay(midlet).setCurrent(frontViewer);
      }
    }
  }

  public void backCommandFromViewer() {
    Display.getDisplay(midlet).setCurrent(this);
    frontViewer = null;
  }
}