package pse.client.framework;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import pse.client.*;

public class ProfileSectionViewer extends Form {

  ProfileSectionViewerListener listener;
  ProfileSectionSelector selector;
  ProfileSectionJ2ME profileSection;
  MIDlet midlet;
  String containers;

  Command commandBack;
  Command commandSections;

  /**Construct the displayable*/
  public ProfileSectionViewer(MIDlet mid, ProfileSectionViewerListener l, ProfileSectionJ2ME ps, String containers) {
    super("Attributes in "+ps.getName()+" ("+containers+")");
    listener = l;
    profileSection = ps;
    midlet = mid;
    this.containers = containers;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    commandBack = new Command("Back", Command.BACK, 1);
    addCommand(commandBack);
    commandSections = new Command("Sections", Command.SCREEN, 1);
    addCommand(commandSections);
    ProfileAttributeJ2ME [] attribs = profileSection.getAttributeList();
    for (int i=0; i<attribs.length; i++) {
      StringItem si = new StringItem(attribs[i].getName()+"= ", attribs[i].getValue());
      append(si);
    }
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    // add your command event handling here
    if (c==commandBack) {
      System.out.println("Selezionato Back");
      listener.backCommandFromViewer();
    }
    else if (c==commandSections) {
      System.out.println("Selezionato CommandSections");
      selector = new ProfileSectionSelector(midlet, this, profileSection.getSectionList(), containers+"/"+profileSection.getName());
      Display.getDisplay(midlet).setCurrent(selector);
    }
  }

  public void backCommandFromSelector() {
    Display.getDisplay(midlet).setCurrent(this);
    selector = null;
  }
}