package pse.client.framework;

import javax.microedition.lcdui.*;

public class RunningWrapperMenuScreen extends List {

  DeviceClient midlet;
  UIListener listener;
  String wrapperName;
  FoundServicesProfiles proxiesProfiles;

  //String commandBack;
  Command commandBack;
  Command commandInfo;
  String commandPause;
  String commandStop;

  /**Construct the displayable*/
  public RunningWrapperMenuScreen(DeviceClient midlet, UIListener l,
        String wrapperName, FoundServicesProfiles fsp) {
    super(wrapperName, List.IMPLICIT);
    this.midlet = midlet;
    listener = l;
    this.wrapperName = wrapperName;
    proxiesProfiles = fsp;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    commandBack = new Command("Back", Command.BACK, 1);
    commandInfo = new Command("Info", Command.SCREEN, 1);
    commandPause = "Pause";
    commandStop = "Stop";
    append(commandStop, null);
    append(commandPause, null);
    addCommand(commandBack);
    addCommand(commandInfo);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==List.SELECT_COMMAND) {
      int selCommandIndex = getSelectedIndex();
      if (selCommandIndex!=-1) {
        String selCommand = getString(selCommandIndex);
        /*if (selCommand.equals(commandBack)) {
          listener.doBackFromWrapperMenu();
        }*/
        if (selCommand.equals(commandPause)) {
          listener.doPauseService(wrapperName);
        }
        else if (selCommand.equals(commandStop)) {
          listener.doStopService(wrapperName);
        }
      }
    }
    else if (c==commandBack) {
      listener.doBackFromWrapperMenu();
    }
    else if (c==commandInfo) {
      listener.doViewActiveWrapperInfo(wrapperName);
    }
  }
}