package pse.client.framework;

import javax.microedition.lcdui.*;

public class SearchSuccededWrapperMenuScreen extends List implements FoundServicesScreenListener {

  DeviceClient midlet;
  UIListener listener;
  String wrapperName;
  FoundServicesProfiles proxiesProfiles;

  //String commandBack;
  Command commandBack;
  Command commandInfo;
  String commandFindProxies;
  String commandStart;
  String commandSelectProxy;

  FoundServiceChooser fsViewer;

  private int selectedProxyIndex = 0; //E' quello che dovr essere modificato dal sottoschermo. Di default il primo proxy della lista

  /**Construct the displayable*/
  public SearchSuccededWrapperMenuScreen(DeviceClient midlet, UIListener l,
        String wrapperName, FoundServicesProfiles fsp) {
    super(wrapperName, List.IMPLICIT);
    this.midlet = midlet;
    listener = l;
    this.wrapperName = wrapperName;
    proxiesProfiles = fsp;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    //commandBack = "Back";
    commandBack = new Command("Back", Command.BACK, 1);
    commandInfo = new Command("Info", Command.SCREEN, 1);
    commandSelectProxy = "Select Proxy";
    commandStart = "Start Service";
    commandFindProxies = "Find Proxies";
    append(commandSelectProxy, null);
    append(commandStart, null);
    append(commandFindProxies, null);
    addCommand(commandBack);
    addCommand(commandInfo);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==List.SELECT_COMMAND) {
      int selCommandIndex = getSelectedIndex();
      if (selCommandIndex!=-1) {
        String selCommand = getString(selCommandIndex);
        /*if (selCommand.equals(commandBack)) {
          listener.doBackFromWrapperMenu();
        }
        */
        if (selCommand.equals(commandStart)) {
          listener.doStartService(wrapperName, selectedProxyIndex);
        }
        else if (selCommand.equals(commandSelectProxy)) {
          if (fsViewer == null) {
            fsViewer = new FoundServiceChooser(midlet, this, proxiesProfiles);
          }
          Display.getDisplay(midlet).setCurrent(fsViewer);
        }
        else if (selCommand.equals(commandFindProxies)) {
          listener.doFindProxies(wrapperName);
        }
      }
    }
    else if (c==commandBack) {
      listener.doBackFromWrapperMenu();
    }
    else if (c==commandInfo) {
      listener.doViewActiveWrapperInfo(wrapperName);
    }
  }

  public void doBackFromFSScreen() {
    Display.getDisplay(midlet).setCurrent(this);
  }

  public void selectedProxy(int proxyIndex) {
    selectedProxyIndex = proxyIndex;
  }

}