package pse.temp.client;

import pse.client.*;
import pse.shared.*;


/**
 * Title:
 * Description:  Step 1 della tesi
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.*;
//import java.net.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;

import com.sun.midp.io.InternalConnector;

public class Wrapper implements ServiceWrapper {

  private ProfileHandlerFinder profileHandlerFinder;

  private String givenWrapperName;
  //Socket sock;
  private StreamConnection sock;
  DataInputStream din;
  DataOutputStream dout;

  public Wrapper() {
  }

  public WrapperProfileJ2ME getWrapperProfile() {
    WrapperProfileJ2ME ret = new WrapperProfileJ2ME("pse.temp.shared.TempInterface");
    ret.addAttribute(new ProfileAttributeJ2ME("WrapperKind", "1"));
    return ret;
  }

  public WrapperInfo getWrapperInfo() {
    return new WrapperInfo("Servizio Temp", "pse.temp.shared.TempInterface");
  }

  public void modifyProfile() {}

  /*
  public void start(ServiceProxy pr, ProfileHandlerFinder profileHandlerFinder, ServiceSessionID sSID) {
    System.out.println("Sono in start. La classe di pr e': "+pr.getClass().getName());
    this.proxy = (TempInterface)pr;
    this.profileHandlerFinder = profileHandlerFinder;
    this.sSID = sSID;
    String res = null;
    try {
      res = proxy.execute();
    }
    catch (RemoteException ex) {
      System.out.println("Errore in Start : "+ex.getMessage());
    }
    System.out.println("Ho eseguito l'elaborazione ed il risulatto e' :"+res);
    try {
      ProfileHandler pH = this.profileHandlerFinder.getProfileHandler();
      pH.getProfile(sSID);
    }
    catch (Exception ex) {
      System.out.println("Errore nell'acquisizione del ProfileHandler");
    }
    System.out.println("Ho richiesto il profilo al ProfileHandler");
  }
  */

  public void start(ProfileHandlerFinder profileHandlerFinder, String wrapperName, String bridgeAddress, int bridgeTCPPort) throws PSEException {
    System.out.println("Sono in start(nuovo). Il mio wrapperName e': "+wrapperName+" la porta a cui connettermi  "+bridgeTCPPort);
    //this.proxy = (TempInterface)pr;
    this.profileHandlerFinder = profileHandlerFinder;
    //this.sSID = sSID;
    this.givenWrapperName = wrapperName;
    //Costruisco la connessione con il bridge
    try {
      //sock = new Socket(bridgeAddress, bridgeTCPPort);
      sock = (StreamConnection)InternalConnector.openInternal("socket://"+bridgeAddress+":"+bridgeTCPPort, Connector.READ_WRITE, false);
      //din = new DataInputStream(sock.getInputStream());
      din = sock.openDataInputStream();
      //dout = new DataOutputStream(sock.getOutputStream());
      dout = sock.openDataOutputStream();
    }
    catch (Exception ex) {
      //throw new PSEException("Error in opening connection with bridge");
      System.out.println("Error in opening connection with bridge");
      throw new PSEException("Error in opening connection with bridge");
    }
  }

  public void run() {
    String res = null;
    try {
      dout.writeUTF("execute");
      res = din.readUTF();
    }
    catch (Exception ex) {
      System.out.println("Error in executing service");
      //throw new PSEException("Error in executing service");
    }
    System.out.println("Ho eseguito l'elaborazione ed il risulatto e' :"+res);
  }

  public void stop() {
    close();
  }

  public void close() {
    if (din!=null) {
      try {
        din.close();
      }
      catch (Exception ex) {
      }
    }
    if (dout != null) {
      try {
        dout.close();
      }
      catch (Exception ex) {
      }
    }
    if (sock!=null) {
      try {
        sock.close();
      }
      catch (Exception ex) {
      }
    }
  }

  public void pause() {}

  public void resume() {}

  public String getBridgeName() {
    return "pse.temp.client.Bridge";
  }
}