package pse.temp.client;

import pse.client.*;
import pse.shared.*;

/**
 * Title:
 * Description:  Step 1 della tesi
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;

import com.sun.midp.io.InternalConnector;

public class Wrapper3 implements ServiceWrapper {

  private WaitingThread waitingThread;
  private final int WAITING_MSC = 1000;

  private ProfileHandlerFinder profileHandlerFinder;

  private String givenWrapperName;
  //private Socket sock;
  private StreamConnection sock;
  private DataInputStream din;
  private DataOutputStream dout;

  public Wrapper3() {
  }

  public WrapperProfileJ2ME getWrapperProfile() {
    WrapperProfileJ2ME ret = new WrapperProfileJ2ME("pse.temp.shared.SboroneInterface");
    ret.addAttribute(new ProfileAttributeJ2ME("WrapperKind", "3"));
    return ret;
  }

  public WrapperInfo getWrapperInfo() {
    return new WrapperInfo("Servizio Sborone", "pse.temp.shared.SboroneInterface");
  }

  public void modifyProfile() {}

  public void start(ProfileHandlerFinder profileHandlerFinder, String wrapperName, String bridgeAddress, int bridgeTCPPort) throws PSEException {
    System.out.println("Sono in start(nuovo). Il mio wrapperName e': "+wrapperName+" la porta a cui connettermi  "+bridgeTCPPort);
    //this.proxy = (TempInterface)pr;
    this.profileHandlerFinder = profileHandlerFinder;
    //this.sSID = sSID;
    this.givenWrapperName = wrapperName;
    //Costruisco la connessione con il bridge
    try {
      //sock = new Socket(bridgeAddress, bridgeTCPPort);
      sock = (StreamConnection)InternalConnector.openInternal("socket://"+bridgeAddress+":"+bridgeTCPPort, Connector.READ_WRITE, false);
      //din = new DataInputStream(sock.getInputStream());
      din = sock.openDataInputStream();
      //dout = new DataOutputStream(sock.getOutputStream());
      dout = sock.openDataOutputStream();
    }
    catch (Exception ex) {
      //throw new PSEException("Error in opening connection with bridge");
      System.out.println("Error in opening connection with bridge");
      throw new PSEException("Error in opening connection with bridge");
    }
  }

  public void run() {
    if (waitingThread==null) {
      waitingThread = new WaitingThread();
      waitingThread.start();
    }
    /*
    else {
      throw new PSEException("Thread already in execution. (Not stopped properly?)");
    }
    */
  }

  public void stop() {
    System.out.println("Sono in Wrapper3.stop.");
    close();
  }

  public void pause() {
    System.out.println("Sono Wrapper3.pause.");
    if (waitingThread != null) {
      waitingThread.pauseIt();
    }
  }

  public void resume() {
    System.out.println("Sono Wrapper3.resume.");
    if (waitingThread != null) {
      waitingThread.resumeIt();
    }
  }

  public void close() {
    if (din!=null) {
      try {
        din.close();
        din = null;
      }
      catch (Exception ex) {
      }
    }
    if (dout != null) {
      try {
        dout.close();
        dout = null;
      }
      catch (Exception ex) {
      }
    }
    if (sock!=null) {
      try {
        sock.close();
        sock = null;
      }
      catch (Exception ex) {
      }
    }
    if (waitingThread!=null) {
      waitingThread.destroy();
      waitingThread = null;
    }
  }

  public String getBridgeName() {
    return "pse.temp.client.Bridge3";
  }

  class WaitingThread extends Thread {
    boolean executing = false;
    boolean paused = false;
    int count = 1;
    static final int maxCount = 10;
    int res;

    public void run() {
      executing = true;
      while (executing) {
        System.out.println("WaitingThread.run() -1");
        if (paused) {
          System.out.println("WaitingThread.run() -2");
          try {
            Thread.sleep(WAITING_MSC);
          }
          catch (InterruptedException ex) {
          }
          //System.out.println("WaitingThread.run() -3");
        }
        else {
          System.out.println("WaitingThread.run() -4");
          if (count <=maxCount) {
            //System.out.println("WaitingThread.run() -5");
            try {
              //System.out.println("WaitingThread.run() -6");
              dout.writeInt(count);
              dout.flush();
              //System.out.println("WaitingThread.run() -7");
              res = din.readInt();
              //System.out.println("WaitingThread.run() -8");
              System.out.println("Ho scritto "+count+" e letto "+res);
              //System.out.println("WaitingThread.run() -9");
              count++;
            }
            catch (IOException ex) {
              System.out.println("Errore di comunicazione durante il count "+count);
            }
          }
          else {
            close();
            profileHandlerFinder.notifyFinished(givenWrapperName);
          }
        }
      }
    }
    public void destroy() {
      executing = false;
    }
    public void pauseIt() {
      paused = true;
    }
    public void resumeIt() {
      paused = false;
    }
  }

}