package pse.client.framework;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.event.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class ClientUI extends JFrame implements IClientUI {

  private IClientUIListener uiListener = null;
  private String selectedService;
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel StatusBar = new JLabel();
  JPanel CommandPanel = new JPanel();
  JButton SearchFrameworkButton = new JButton();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField userNameTF = new JTextField();
  JLabel jLabel2 = new JLabel();
  JTextField pwdTF = new JTextField();
  JButton LoginButton = new JButton();
  JPanel jPanel2 = new JPanel();
  JTextArea ReportArea = new JTextArea();
  BorderLayout borderLayout3 = new BorderLayout();
  JList wrappersList = new JList();
  JButton StartServiceButton = new JButton();
  JButton LogoutButton = new JButton();

  public ClientUI(IClientUIListener uiListener) {
    this.uiListener = uiListener;
    try {
      jbInit();
    }
    catch(Exception e) {
      //e.printStackTrace();
      System.out.println("Errore in ClientUI : "+e.getMessage());
    }
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    SearchFrameworkButton.setText("Search Framework...");
    SearchFrameworkButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        SearchFrameworkButton_actionPerformed(e);
      }
    });
    CommandPanel.setLayout(borderLayout2);
    jLabel1.setText("User Name");
    jLabel2.setText("password");
    pwdTF.setMinimumSize(new Dimension(63, 21));
    pwdTF.setPreferredSize(new Dimension(40, 21));
    pwdTF.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        pwdTF_actionPerformed(e);
      }
    });
    LoginButton.setText("Login");
    LoginButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        LoginButton_actionPerformed(e);
      }
    });
    userNameTF.setMinimumSize(new Dimension(40, 21));
    userNameTF.setPreferredSize(new Dimension(40, 21));
    StatusBar.setText("Status...");
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosed(WindowEvent e) {
        this_windowClosed(e);
      }
      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    jPanel2.setLayout(borderLayout3);
    wrappersList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    wrappersList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        wrappersList_valueChanged(e);
      }
    });
    ReportArea.setPreferredSize(new Dimension(200, 17));
    StartServiceButton.setText("Start Service");
    StartServiceButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        StartServiceButton_actionPerformed(e);
      }
    });
    LogoutButton.setText("Logout");
    LogoutButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        LogoutButton_actionPerformed(e);
      }
    });
    jPanel1.add(jLabel1, null);
    jPanel1.add(userNameTF, null);
    jPanel1.add(jLabel2, null);
    jPanel1.add(pwdTF, null);
    jPanel1.add(LoginButton, null);
    jPanel1.add(LogoutButton, null);
    jPanel1.add(StartServiceButton, null);
    this.getContentPane().add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(ReportArea, BorderLayout.WEST);
    jPanel2.add(wrappersList, BorderLayout.CENTER);
    CommandPanel.add(SearchFrameworkButton, BorderLayout.NORTH);
    CommandPanel.add(jPanel1, BorderLayout.SOUTH);
    this.getContentPane().add(StatusBar, BorderLayout.SOUTH);
    this.getContentPane().add(CommandPanel, BorderLayout.NORTH);
  }

  public void showStatusMessage(String message) {
    StatusBar.setText(message);
  }

  public void setWrapperList(Vector wrapperList) {
    wrappersList.setListData(wrapperList);
  }

  public void foundFramework() {
    StatusBar.setText("Framework Found. Please Login.");
  }

  public void loggedIn() {
    StatusBar.setText("Login correct. Choose a service to run");
    uiListener.findWrappers();
  }

  public void loggedOut() {
  }

  public void selectActivation(int status) {
  }

  public void logThis(String message) {
    ReportArea.append(message+"\n");
  }

  void SearchFrameworkButton_actionPerformed(ActionEvent e) {
    StatusBar.setText("Searching Framework...");
    uiListener.searchFramework();
  }

  void this_windowClosed(WindowEvent e) {
    System.exit(0);
  }

  void this_windowClosing(WindowEvent e) {
    System.exit(0);
  }

  void pwdTF_actionPerformed(ActionEvent e) {

  }

  void wrappersList_valueChanged(ListSelectionEvent e) {
    String us = (String)wrappersList.getSelectedValue();
    if (us != null) ReportArea.setText("Selezionato Servizio : "+us);
    selectedService = us;
  }

  void LoginButton_actionPerformed(ActionEvent e) {
    uiListener.login(userNameTF.getText(), pwdTF.getText());
  }

  void StartServiceButton_actionPerformed(ActionEvent e) {
    if (selectedService == null) {
      StatusBar.setText("Choose a Service before");
      return;
    }
    StatusBar.setText("Richiesta di avviare il servizio "+selectedService);
    uiListener.startService(selectedService);
  }

  void LogoutButton_actionPerformed(ActionEvent e) {
    if (uiListener != null)
      uiListener.logout();
  }
}