package pse.client.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.shared.*;
import pse.client.*;
import pse.shared.framework.*;

public class ServiceDescriptor {

  /*informazioni contenute:
  -ServiceWrapper
  -Stato
  -Proxy scaricati
  -Indice del proxy utilizzato
  */

  static final int NOT_SEARCHED = 0;
  static final int SEARCH_FAILED = 1;
  static final int SEARCH_SUCCEEDED = 2;
  static final int RUNNING = 3;
  static final int PAUSED = 4;

  private ServiceWrapper wrapper;
  private int state;
  private int wrapperIndex;
  private FoundServices foundServices; //ha significato solo in stati SEARCH_FAILED, RUNNING e PAUSED
  private int activeService; //ha significato solo in stati RUNNING e PAUSED
  private ServiceSessionID sSID; //ha significato solo in stati RUNNING e PAUSED

  public ServiceDescriptor(ServiceWrapper sw) {
    wrapper = sw;
    state = NOT_SEARCHED;
    wrapperIndex = 1;
  }

  public ServiceWrapper getServiceWrapper() {
    return wrapper;
  }

  public void setState(int newState) {
    state = newState;
  }

  public int getState() {
    return state;
  }

  public void setWrapperIndex(int wi) {
    wrapperIndex = wi;
  }

  public int getWrapperIndex() {
    return wrapperIndex;
  }

  public void setFoundServices(FoundServices fs) {
    foundServices = fs;
  }

  public FoundServices getFoundServices() {
    return foundServices;
  }

  public void setActiveProxyIndex(int index) {
    activeService = index;
  }

  public int getActiveProxyIndex() {
    return activeService;
  }

  public void setServiceSessionID(ServiceSessionID sSID) {
    this.sSID = sSID;
  }

  public ServiceSessionID getServiceSessionID() {
    return sSID;
  }




}