package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import javax.swing.*;
import javax.swing.tree.*;

import pse.shared.*;

public class ClientProfileNode extends DefaultMutableTreeNode {

  private ClientProfile cp;

  public ClientProfileNode(ClientProfile cp) {
    super(cp);
    this.cp = cp;
    ProfileSectionNode deviceNode = null;
    if (cp.getDeviceProfile()!=null) {
      deviceNode = new ProfileSectionNode(cp.getDeviceProfile());
      add(deviceNode);
    }
    ProfileSectionNode userNode = null;
    if (cp.getUserProfile()!=null) {
      userNode = new ProfileSectionNode(cp.getUserProfile());
      add(userNode);
    }
    ProfileSection services = new ProfileSection("Services");
    ProfileSectionNode servicesNode = new ProfileSectionNode(services);
    add(servicesNode);
    String [] servs = cp.getServicesWithProfile();
    if (servs != null) {
      for (int i=0; i<servs.length; i++) {
        String sName = servs[i];
        ProfileSection ps = new ProfileSection(sName);
        ProfileSectionNode psn = new ProfileSectionNode(ps);
        servicesNode.add(psn);
        //La ServicePreferences
        ServicePreferences servPref = cp.getServicePreferences(sName);
        if (servPref!=null) {
          ProfileSectionNode servPrefNode = new ProfileSectionNode(servPref);
          psn.add(servPrefNode);
        }
        //I WrapperProfiles
        ProfileSection wrapDir = new ProfileSection("Wrappers");
        ProfileSectionNode wrapDirNode = new ProfileSectionNode(wrapDir);
        psn.add(wrapDirNode);
        WrapperProfile [] wrappProf = cp.getWrapperProfile(sName);
        if (wrappProf != null) {
          for (int j=0; j<wrappProf.length; j++) {
            ProfileSectionNode wrappProfNode = new ProfileSectionNode(wrappProf[j]);
            wrapDirNode.add(wrappProfNode);
          }
        }
      }
    }
  }

  public String toString() {
    return cp.getName();
  }
}