package pse.temp.client;

import pse.client.*;
import pse.shared.*;
import pse.temp.shared.*;
import java.rmi.RemoteException;

/**
 * Title:
 * Description:  Step 1 della tesi
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class Wrapper implements ServiceWrapper {

  private TempInterface proxy;
  private ProfileHandlerFinder profileHandlerFinder;
  private ServiceSessionID sSID;

  public Wrapper() {
  }

  public WrapperProfile getWrapperProfile() {
    WrapperProfile ret = new WrapperProfile("pse.temp.shared.TempInterface");
    ret.addAttribute(new ProfileAttribute("WrapperKind", "1"));
    return ret;
  }

  public WrapperInfo getWrapperInfo() {
    return new WrapperInfo("Servizio Temp", "pse.temp.shared.TempInterface");
  }

  public void modifyProfile() {}

  public void start(ServiceProxy pr, ProfileHandlerFinder profileHandlerFinder, ServiceSessionID sSID) {
    System.out.println("Sono in start. La classe di pr e': "+pr.getClass().getName());
    this.proxy = (TempInterface)pr;
    this.profileHandlerFinder = profileHandlerFinder;
    this.sSID = sSID;
    String res = null;
    try {
      res = proxy.execute();
    }
    catch (RemoteException ex) {
      System.out.println("Errore in Start : "+ex.getMessage());
    }
    System.out.println("Ho eseguito l'elaborazione ed il risulatto e' :"+res);
    try {
      ProfileHandler pH = this.profileHandlerFinder.getProfileHandler();
      pH.getProfile(sSID);
    }
    catch (Exception ex) {
      System.out.println("Errore nell'acquisizione del ProfileHandler");
    }
    System.out.println("Ho richiesto il profilo al ProfileHandler");
  }

  public void stop() {}

  public void pause() {}

  public void resume() {}
}