package pse.temp.client;

import pse.client.*;
import pse.shared.*;
import pse.temp.shared.*;
import java.rmi.RemoteException;

/**
 * Title:
 * Description:  Step 1 della tesi
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class Wrapper3 implements ServiceWrapper {

  private SboroneInterface proxy;
  private ProfileHandlerFinder profileHandlerFinder;
  private ServiceSessionID sSID;

  private Thread waitingThread;
  private final int WAITING_MSC = 5000;
  private int timesResumed = 0;

  public Wrapper3() {
  }

  public WrapperProfile getWrapperProfile() {
    WrapperProfile ret = new WrapperProfile("pse.temp.shared.SboroneInterface");
    ret.addAttribute(new ProfileAttribute("WrapperKind", "3"));
    return ret;
  }

  public WrapperInfo getWrapperInfo() {
    return new WrapperInfo("Servizio Sborone", "pse.temp.shared.SboroneInterface");
  }

  public void modifyProfile() {}

  public void start(ServiceProxy pr, final ProfileHandlerFinder profileHandlerFinder, final ServiceSessionID sSID) {
    System.out.println("Sono in start. La classe di pr e': "+pr.getClass().getName());
    this.proxy = (SboroneInterface)pr;
    this.profileHandlerFinder = profileHandlerFinder;
    this.sSID = sSID;
    String res = null;
    try {
      res = proxy.executeDaSborone();
    }
    catch (RemoteException ex) {
      System.out.println("Errore in Start : "+ex.getMessage());
    }
    System.out.println("Ho eseguito l'elaborazione ed il risultato e' :"+res);
    try {
      ProfileHandler pH = this.profileHandlerFinder.getProfileHandler();
      pH.getProfile(sSID);
    }
    catch (Exception ex) {
      System.out.println("Errore nell'acquisizione del ProfileHandler");
    }
    System.out.println("Ho richiesto il profilo al ProfileHandler");
    waitingThread = new WaitingThread();
    waitingThread.start();
  }

  public void stop() {
    System.out.println("Sono in stop. La classe di pr e': "+proxy.getClass().getName());
    waitingThread.destroy();
    waitingThread = null;
  }

  public void pause() {
    System.out.println("Sono in pause. La classe di pr e': "+proxy.getClass().getName());
    if (waitingThread != null) {
      waitingThread.destroy();
      waitingThread = null;
    }
  }

  public void resume() {
    timesResumed++;
    System.out.println("Sono in resume. La classe di pr e': "+proxy.getClass().getName());
    waitingThread = new WaitingThread();
    waitingThread.start();
  }

  class WaitingThread extends Thread {
    boolean destroyed = false;
    public void run() {
      try {
        Thread.sleep(WAITING_MSC);
      }
      catch (InterruptedException ex) {
      }
      if (!destroyed) {
        System.out.println("Times resumed = "+timesResumed);
        profileHandlerFinder.notifyFinished(sSID);
      }
    }
    public void destroy() {
      destroyed = true;
    }
  }
}