package pse.client.framework;


import java.io.*;
import java.net.*;
import java.util.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class Client01Temp  {
}

class SurrogateClient {

  private int PROTOCOL_VERSION;
  private InetAddress multicastRequestAddress;
  private int multicastRequestPort;
  private InetAddress myAddress;
  private int unicastResponsePort;

  private DatagramSocket reqSocket;
  //Provo a usare quella sopra sia per mandare che per ricevere
  //private DatagramSocket respSocket;

  private InetAddress registrationAddress;
  private int registrationTCPPort;
  private int registrationUDPPort;

  private long codice = 1;
  String jarFileName;
  Socket sock;
  DataOutputStream dos;

  ServerSocket ss;
  Socket appSocket;
  private DataInputStream appDis;
  private DataOutputStream appDos;

  private SurrogateClient instance;

  public static void main (String[] args) {
    new SurrogateClient();
  }

  public SurrogateClient() {
    setDefaults();
    findSurrogateHost();
    registerSurrogate();
    try {
      Thread.sleep(1000);
      //Perch altrimenti capita che provo a fare wrtire sulla socket prima di aver fatto accept
    }
    catch (InterruptedException ex) {
      //continue;
    }

    callService();
    shutDown();
  }

  private void setDefaults() {
    PROTOCOL_VERSION = 1;
    try {
      multicastRequestAddress = InetAddress.getByName("224.0.1.95");
      myAddress = InetAddress.getLocalHost();
    } catch (Exception e) {
        System.out.println("Errore nella creazione dell'InetAddress: "+e.getMessage());
      }
    multicastRequestPort = 1925;
    //unicastResponsePort = 1925;
    try {
      reqSocket = new DatagramSocket(45674);
      unicastResponsePort =reqSocket.getLocalPort();
      System.out.println("Sockey registrata: Indirizzo = "+reqSocket.getLocalAddress().getHostAddress());
      System.out.println("Porta = "+unicastResponsePort);
      //System.out.println("Creata la socket all'indirizzo: "+reqSocket.getInetAddress().getHostAddress()+":"+reqSocket.getPort());
    } catch (Exception e) {
        System.out.println("Errore nella creazione della socket reqSocket :"+e.getMessage());
    }
    jarFileName="surr.jar";
  }

  private void shutDown() {
    if (reqSocket!=null) {
      reqSocket.close();
    }
  }

  private void findSurrogateHost() {
    try {
      //Mando la richiesta
      System.out.println("Costruisco il datagram packet...");
      DatagramPacket pkt = marshalOutgoingHostRequest(multicastRequestAddress, multicastRequestPort, 12345);
      System.out.println("Invio il datagramma all'indirizzo di Multicast");
      reqSocket.send(pkt);
      System.out.println("Mandata la richiesta. Ora attendo la risposta...");
      byte[] buf = new byte[512];
      DatagramPacket rpkt = new DatagramPacket(buf, buf.length);
      reqSocket.receive(rpkt);
      System.out.println("Ho ricevuto qualcosa. Adesso parso...");
      try {
        byte[] bytes = rpkt.getData();
        DataInputStream dis =
            new DataInputStream(new ByteArrayInputStream(bytes));
        IncomingHostResponse resp = new IncomingHostResponse(dis);
        registrationAddress = resp.getHostAddress();
        registrationTCPPort = resp.tcpPort;
        registrationUDPPort=  resp.udpPort;
        System.out.println("Il messaggio che ho ricevuto e' cosi' composto : \nAddress = "+resp.getHostAddress()+"\nTCP port = "+resp.tcpPort+"\nUDP port = "+resp.udpPort);
      } catch (Exception e) {
        System.out.println("Errore in lettura della risposte: "+e.getMessage());
      }
    } catch (Exception e) {
        System.out.println("Errore in findSurrogateHost() "+e.getMessage());
      }
  }//findSurrogateHost

  private void registerSurrogate() {
    try {
      System.out.println("Apro la socket per registrare il surrogate");
      sock = new Socket(registrationAddress, registrationTCPPort);
      ss = new ServerSocket(0);
      new ListeningThread(ss).start();
      try {
        //Pre per mettere alla socket di mettersi in ascolto...
        System.out.println("Dormo un po'");
        Thread.sleep(500);
        System.out.println("Ora mi sveglio");
      }
      catch (Exception ex) {

      }

      // generate initialization data
      System.out.println("Costruisco l'initialization data");
      ByteArrayOutputStream bos = new ByteArrayOutputStream();
      dos = new DataOutputStream(bos);
      dos.writeLong(codice);
      System.out.println("Ho scritto :"+codice);
      dos.writeShort(ss.getLocalPort());
      System.out.println("Ho scritto :"+ss.getLocalPort());
      dos.flush();
      byte[] initData = bos.toByteArray();

      System.out.println("Predo il contenuto del file jar");
      File jarFile = new File(jarFileName);
      FileInputStream fis = new FileInputStream(jarFile);

      System.out.println("Scrivo il messaggio sulla socket...");
      dos = new DataOutputStream(sock.getOutputStream());
      dos.writeInt(PROTOCOL_VERSION);
      System.out.println("Scrivo: "+PROTOCOL_VERSION);
      dos.writeShort(0); // set the length of surrogate URL as 0
      System.out.println("Scrivo: 0");
      dos.writeInt(initData.length);
      System.out.println("Scrivo: "+initData.length);
      dos.write(initData, 0, initData.length);
      System.out.println("Scrivo: il contenuto di initData");

      // write the jar out
      dos.writeInt((int)jarFile.length());
      System.out.println("Scrivo: "+(int)jarFile.length());
      byte[] buff = new byte[1024];
      int len = fis.read(buff);
      while (len > 0) {
          dos.write(buff, 0, len);
          len = fis.read(buff);
      }
      dos.flush();
      System.out.println("Scrivo: il contenuto del jar file");
    }
    catch (Exception ex) {
      System.out.println("Errore nella fase ri registrazione del surrogate: "+ex.getMessage());
    }
    finally{
      //ATT.NE! Questo  fondamentale! Altrimenti madison lancia socketException (ma perch poi ?!?!?)
      System.out.println("Sono nel finally");
      try {
          if (dos != null)
            dos.close();
          if (sock != null)
              sock.close();
          /*if (ss != null)
            ss.close();*/
      } catch(IOException e) {}
    }
  }//registerSurrogate

  private void callService() {
    try {
      //Scrivere UID e PWD su appDOS
      System.out.println("callService() - 1");
      appDos.writeUTF("Me");
      System.out.println("callService() - 2");
      appDos.writeUTF("Medesimo");
      System.out.println("callService() - 3");
      boolean res = appDis.readBoolean();
      System.out.println("callService() - 4");
      System.out.println("Ho richiesto login con Me:Medesimo. Il risultato  stato : "+res);
    }
    catch (Exception ex) {
      System.err.println("Errore in callService : "+ex.getMessage());
    }
    finally {
      try {
        appDos.close();
        appDis.close();
        appSocket.close();
      } catch (Exception e) {
          System.out.println("Errore nella chiusura di appSocket");
        }
    }
  }

  /**
   * Costruisce un Datagram di Multicast Host Request
   * @param hostAddres indirizzo multicast a cui mandare la richiesta
   * @param porta a cui mandare la richiesta
   * @param porta su cui si attendono risposte
   */
  private DatagramPacket
        marshalOutgoingHostRequest(InetAddress hostAddr, int reqPort,
                                   int respPort) throws IOException
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(bos);
        dos.writeInt(PROTOCOL_VERSION);
        //String addr = deviceAddress.getHostAddress();
        String addr = myAddress.getHostAddress();
        dos.writeShort(addr.length());
        dos.writeBytes(addr);
        dos.writeShort(unicastResponsePort);
        dos.flush();
        byte[] message = bos.toByteArray();
        /*if (message.length > Constants.MAX_MULTICAST_PKT_SIZE)
            throw new IllegalArgumentException("device address marshals " +
                                               "too large");*/
        return new DatagramPacket(message, message.length, hostAddr, reqPort);
    }

  private class IncomingHostResponse {
        private InetAddress hostAddress;
        private int tcpPort;
        private int udpPort;

        /** Parse a response message from a host. */
        IncomingHostResponse(DataInputStream dis) throws IOException {
            int version = dis.readInt();
            if (version != PROTOCOL_VERSION)
                throw new IOException("unsupported protocol version: " +
                                      version);

            // host address
            int addrLen = dis.readUnsignedShort();
            if (addrLen > 0) {
                byte[] addrData = new byte[addrLen];
                dis.readFully(addrData);
                hostAddress = InetAddress.getByName(new String(addrData));
            } else {
                if (System.getProperty("com.sun.jini.madison.debug") != null)
                    System.err.println("Host response with no host address!");
                throw new IOException("Host response with no host address!");
            }
            tcpPort = dis.readUnsignedShort();
            udpPort = dis.readUnsignedShort();
            dis.close();
        }

        public InetAddress getHostAddress() {
            return hostAddress;
        }

        public int getTCPPort() {
            return tcpPort;
        }

        public int getUDPPort() {
            return udpPort;
        }

        public boolean equals(Object o) {
            if (!(o instanceof IncomingHostResponse))
                return false;
            IncomingHostResponse resp = (IncomingHostResponse)o;
            return hostAddress.equals(resp.hostAddress) &&
                tcpPort == resp.tcpPort && udpPort == resp.udpPort;
        }
    }//IncomingHostResponse

    private class ListeningThread extends Thread {
      ServerSocket servSock;

      ListeningThread(ServerSocket servSock) {
        this.servSock = servSock;
      }

      public void run() {
        try {
          System.out.println("Sono ListeningSocket. Sto per fare accept()");
          appSocket = ss.accept();
          System.out.println("Sono ListeningSocket. Ho accept()");
          appDis = new DataInputStream(appSocket.getInputStream());
          appDos = new DataOutputStream(appSocket.getOutputStream());
        } catch (Exception e) {
            System.out.println("Errore nella accept: "+e.getMessage());
        } finally {
          try {
            ss.close();
          }
          catch (Exception ex) {
            System.out.println("Errore nella chiusura di ss");
          }
        }
      }
    }
}
