package pse.client.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.*;

import pse.shared.*;
import pse.shared.framework.*;
import pse.client.*;

import java.io.Serializable;
import java.util.Vector;
import java.rmi.RemoteException;

public final class FoundServicesProfiles implements Serializable {

  private Vector services;

  public FoundServicesProfiles() {
    services = new Vector();
  }

  public FoundServicesProfiles(Vector profiles) {
    services = profiles;
  }

  public Vector getServices() {
    return services;
  }

  public int getNumberOfServices() {
    return services.size();
  }

  public ServerProfileJ2ME getServerProfile(int index) throws ArrayIndexOutOfBoundsException {
    if (index>getNumberOfServices()) throw new ArrayIndexOutOfBoundsException();
    return (ServerProfileJ2ME)services.elementAt(index);
  }

  public static void writeToStream(FoundServicesProfiles fsp, DataOutputStream stream) throws IOException {
    //Scrivo da quanti Profili  costituito
    int howMany = fsp.getNumberOfServices();
    stream.writeInt(howMany);
    System.out.println("FoundServicesProfiles.writeToStream: Ne scrivo: "+howMany);
    //Scrivo ognuno dei profili
    for (int i=0; i<howMany; i++) {
      System.out.println("FoundServicesProfiles.writeToStream. "+i+" = "+fsp.getServerProfile(i));
      ServerProfileJ2ME.writeToStream(fsp.getServerProfile(i), stream);
    }
  }

  public static FoundServicesProfiles readFromStream(DataInputStream stream) throws IOException {
    //Leggo da quanti profili  costituito
    int howMany = stream.readInt();
    System.out.println("FoundServicesProfiles.readFromStream: Ne leggo: "+howMany);
    Vector temp = new Vector();
    for (int i=0; i<howMany; i++) {
      ServerProfileJ2ME spTemp = (ServerProfileJ2ME)ServerProfileJ2ME.readFromStream(stream);
      System.out.println("FoundServicesProfiles.readFromStream. "+i+" = "+spTemp);
      temp.add(i, spTemp);
    }
    return new FoundServicesProfiles(temp);
  }

}