package pse.client.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.client.*;
import pse.shared.*;

public class ProfileConverter {

  public ProfileConverter() {
  }

  public static ProfileAttribute raise(ProfileAttributeJ2ME prof) {
    return new ProfileAttribute(prof.getName(), prof.getValue());
  }

  public static ProfileAttributeJ2ME lower(ProfileAttribute prof) {
    return new ProfileAttributeJ2ME(prof.getName(), (String)prof.getValue());
  }

  private static ProfileAttribute [] raise(ProfileAttributeJ2ME [] profl) {
    int l = profl.length;
    ProfileAttribute [] res = new ProfileAttribute[l];
    for (int i=0; i<l; i++) {
      res[i]=raise(profl[i]);
    }
    return res;
  }

  private static ProfileAttributeJ2ME [] lower(ProfileAttribute [] profl) {
    int l = profl.length;
    ProfileAttributeJ2ME [] res = new ProfileAttributeJ2ME[l];
    for (int i=0; i<l; i++) {
      res[i]=lower(profl[i]);
    }
    return res;
  }

  public static ProfileSection raise(ProfileSectionJ2ME prof) {
    return new ProfileSection(prof.getName(), raise(prof.getSectionList()), raise(prof.getAttributeList()));
  }

  public static ProfileSectionJ2ME lower(ProfileSection prof) {
    return new ProfileSectionJ2ME(prof.getName(), lower(prof.getSectionList()), lower(prof.getAttributeList()));
  }

  private static ProfileSection [] raise(ProfileSectionJ2ME [] profl) {
    int l = profl.length;
    ProfileSection res [] = new ProfileSection[l];
    for (int i=0; i<l; i++) {
      res[i]=raise(profl[i]);
    }
    return res;
  }

  private static ProfileSectionJ2ME [] lower(ProfileSection [] profl) {
    int l = profl.length;
    ProfileSectionJ2ME res [] = new ProfileSectionJ2ME[l];
    for (int i=0; i<l; i++) {
      res[i]=lower(profl[i]);
    }
    return res;
  }

  public static DeviceProfile raise(DeviceProfileJ2ME prof) {
    DeviceProfile res = new DeviceProfile();
    res.addAttributeList(raise(prof.getAttributeList()));
    res.addSectionList(raise(prof.getSectionList()));
    return res;
  }

  public static DeviceProfileJ2ME lower(DeviceProfile prof) {
    DeviceProfileJ2ME res = new DeviceProfileJ2ME();
    res.addAttributeList(lower(prof.getAttributeList()));
    res.addSectionList(lower(prof.getSectionList()));
    return res;
  }

  public static WrapperProfile raise(WrapperProfileJ2ME prof) {
    WrapperProfile res = new WrapperProfile(prof.getServiceInterface(), prof.getWrapperIndex());
    res.addAttributeList(raise(prof.getAttributeList()));
    res.addSectionList(raise(prof.getSectionList()));
    return res;
  }

  public static WrapperProfileJ2ME lower(WrapperProfile prof) {
    WrapperProfileJ2ME res = new WrapperProfileJ2ME(prof.getServiceInterface(), prof.getWrapperIndex());
    res.addAttributeList(lower(prof.getAttributeList()));
    res.addSectionList(lower(prof.getSectionList()));
    return res;
  }

  public static UserProfile raise(UserProfileJ2ME prof) {
    UserProfile res = new UserProfile();
    res.addAttributeList(raise(prof.getAttributeList()));
    res.addSectionList(raise(prof.getSectionList()));
    return res;
  }

  public static UserProfileJ2ME lower(UserProfile prof) {
    UserProfileJ2ME res = new UserProfileJ2ME();
    res.addAttributeList(lower(prof.getAttributeList()));
    res.addSectionList(lower(prof.getSectionList()));
    return res;
  }

  public static ServicePreferences raise(ServicePreferencesJ2ME prof) {
    ServicePreferences res = new ServicePreferences(prof.getServiceInterface());
    res.addAttributeList(raise(prof.getAttributeList()));
    res.addSectionList(raise(prof.getSectionList()));
    return res;
  }

  public static ServicePreferencesJ2ME lower(ServicePreferences prof) {
    ServicePreferencesJ2ME res = new ServicePreferencesJ2ME(prof.getServiceInterface());
    res.addAttributeList(lower(prof.getAttributeList()));
    res.addSectionList(lower(prof.getSectionList()));
    return res;
  }

  public static ServerProfile raise(ServerProfileJ2ME prof) {
    ServerProfile res = new ServerProfile(prof.getServiceInterface());
    res.addAttributeList(raise(prof.getAttributeList()));
    res.addSectionList(raise(prof.getSectionList()));
    return res;
  }

  public static ServerProfileJ2ME lower(ServerProfile prof) {
    ServerProfileJ2ME res = new ServerProfileJ2ME(prof.getServiceInterface());
    res.addAttributeList(lower(prof.getAttributeList()));
    res.addSectionList(lower(prof.getSectionList()));
    return res;
  }

}