package pse.client.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.shared.*;
import pse.client.*;
import pse.shared.framework.*;

public class ServiceDescriptor {

  /*informazioni contenute:
  -ServiceWrapper
  -Stato
  -Proxy scaricati
  -Indice del proxy utilizzato
  */

  static final int NOT_SEARCHED = 0;
  static final int SEARCH_FAILED = 1;
  static final int SEARCH_SUCCEEDED = 2;
  static final int RUNNING = 3;
  static final int PAUSED = 4;

  private ServiceWrapper wrapper;
  private int state;
  private int wrapperIndex;
  private FoundServicesProfiles foundServicesProfiles; //ha significato solo in stati SEARCH_FAILED, RUNNING e PAUSED
  private int activeService; //ha significato solo in stati RUNNING e PAUSED
  private ServiceSessionID sSID; //ha significato solo in stati RUNNING e PAUSED
  //TODO introdotto in tesi03. Fare controlli sul suo trasferiemnto...
  /*
  private boolean bridgeTransferred = false;
  private boolean profileTransferred = false;
  */
  private int bridgeIndex;

  public ServiceDescriptor(ServiceWrapper sw) {
    wrapper = sw;
    state = NOT_SEARCHED;
    wrapperIndex = 1;
  }

  public ServiceWrapper getServiceWrapper() {
    return wrapper;
  }

  public void setState(int newState) {
    state = newState;
  }

  public int getState() {
    return state;
  }

  public void setWrapperIndex(int wi) {
    wrapperIndex = wi;
  }

  public int getWrapperIndex() {
    return wrapperIndex;
  }

  public void setFoundServicesProfiles(FoundServicesProfiles fs) {
    foundServicesProfiles = fs;
  }

  public FoundServicesProfiles getFoundServicesProfiles() {
    return foundServicesProfiles;
  }

  public void setActiveProxyIndex(int index) {
    activeService = index;
  }

  public int getActiveProxyIndex() {
    return activeService;
  }

  public void setServiceSessionID(ServiceSessionID sSID) {
    this.sSID = sSID;
  }

  public ServiceSessionID getServiceSessionID() {
    return sSID;
  }

  /*public boolean isBridgeTransferred() {
    return bridgeTransferred;
  }

  public void setBridgeTransferred(boolean transf) {
    bridgeTransferred = transf;
  }

  public boolean isProfileTransferred() {
    return profileTransferred;
  }

  public void setProfileTransferred(boolean transf) {
    profileTransferred = transf;
  }*/

  public int getBridgeIndex() {
    return bridgeIndex;
  }

  public void setBridgeIndex(int brIndex) {
    bridgeIndex = brIndex;
  }

}