package pse.client.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.net.*;
import java.io.*;
import pse.shared.*;
import pse.client.*;

public class SurrogateMessenger {

  SurrogateMessengerListener listener;
  Socket callSocket;
  Socket responseSocket;
  /*
  ObjectOutputStream callOutput;
  ObjectInputStream callInput;
  ObjectOutputStream responseOutput;
  ObjectInputStream responseInput;
  */
  DataOutputStream callOutput;
  DataInputStream callInput;
  DataOutputStream responseOutput;
  DataInputStream responseInput;
  ListeningThread listeningThread;
  boolean deviceAlive;

  public SurrogateMessenger(SurrogateMessengerListener listener, Socket callSocket, Socket responseSocket) {
    this.listener = listener;
    this.callSocket = callSocket;
    this.responseSocket = responseSocket;
    //Aprire gli Stream
    System.out.println("SurrogateMessenger -2");
    try {
      System.out.println("SurrogateMessenger -3");
      //responseOutput = new ObjectOutputStream(responseSocket.getOutputStream());
      responseOutput = new DataOutputStream(responseSocket.getOutputStream());
      System.out.println("SurrogateMessenger -4");
      //responseInput = new ObjectInputStream(responseSocket.getInputStream());
      responseInput = new DataInputStream(responseSocket.getInputStream());
      System.out.println("SurrogateMessenger -5");
      //callOutput = new ObjectOutputStream(callSocket.getOutputStream());
      callOutput = new DataOutputStream(callSocket.getOutputStream());
      System.out.println("SurrogateMessenger -6");
      //callInput = new ObjectInputStream(callSocket.getInputStream());
      callInput = new DataInputStream(callSocket.getInputStream());
      System.out.println("SurrogateMessenger -7");
    }
    catch (IOException e) {
      System.out.println("Errore nella creazione degli stream: "+e.getMessage());
    }
    listeningThread = new ListeningThread();
    listeningThread.start();
  }

  public void destroy() {
    if (callOutput != null) {
      try {
        callOutput.close();
      }
      catch (IOException ex) {
      }
    }
    if (callInput != null) {
      try {
        callInput.close();
      }
      catch (IOException ex) {
      }
    }
    if (responseOutput != null) {
      try {
        responseOutput.close();
      }
      catch (IOException ex) {
      }
    }
    if (responseInput != null) {
      try {
        responseInput.close();
      }
      catch (IOException ex) {
      }
    }
  }

  public synchronized void foundFramework() throws PSEException {
    try {
      callOutput.writeInt(PSEMessage.FOUND_FRAMEWORK);
      callOutput.flush();
    }
    catch (IOException ex) {
      throw new PSEException(ex.getMessage());
    }
    return; //Cos  non bloccante
  }

  public void keepAlive(long period) throws PSEException {
    try {
      callOutput.writeInt(PSEMessage.KEEP_ALIVE);
      callOutput.writeLong(period);
      callOutput.flush();
    }
    catch (IOException ex) {
      throw new PSEException(ex.getMessage());
    }
  }

  class ListeningThread extends Thread {
    ListeningThread() {
    }
    public void run() {
      int msgType;
      //Questo qui non fa altro che sospendersi sulla socket di ascolto, ed inoltrare le richieste al listener
      while (true) {
        try {
          System.out.println("aspetto msg");
          msgType = responseInput.readInt();
          System.out.println("ho letto msgType = "+msgType);
        }
        catch (IOException ex) {
          System.out.println("Errore in ricezione: "+ex.getMessage());
          break;
          //Fare qlcs di meglio
        }
        try {
          switch (msgType) {
            case PSEMessage.FIND_FRAMEWORK:
                    try {
                      listener.findFramework();
                    }
                    catch (PSEException ex) {
                      //Se dovessi comunicare il risultato dell'esecuzione (sicnrona) qui metterei che c' stato qlcs che non  andato bene
                    }
                    //E' non bloccante. Non devo tornare nulla
                    break;
            case PSEMessage.LOGIN:
                    SessionID sID = null;
                    String un = null;
                    String pwd = null;
                    DeviceProfileJ2ME dp = null;
                    try {
                      //un = (String)responseInput.readObject();
                      un = (String)responseInput.readUTF();
                      System.out.println("Ho letto da responseInput un = "+un);
                      //pwd = (String)responseInput.readObject();
                      pwd = (String)responseInput.readUTF();
                      System.out.println("Ho letto da responseInput pwd = "+pwd);
                      //dp = (DeviceProfileJ2ME)responseInput.readObject();
                      dp = (DeviceProfileJ2ME)DeviceProfileJ2ME.readFromStream(responseInput);
                      System.out.println("Ho letto da responseInput dp = "+dp);
                      }
                    catch (Exception ex) {
                      responseOutput.writeInt(PSEMessage.ERROR);
                      responseOutput.flush();
                      break;
                    }
                    try {
                      listener.login(un, pwd, dp);
                    }
                    catch (PSEException ex) {
                      responseOutput.writeInt(PSEMessage.LOGIN_FAILURE);
                      responseOutput.flush();
                      break;
                    }
                    try {
                      responseOutput.writeInt(PSEMessage.LOGIN_SUCCESS);
                      //responseOutput.writeObject(sID);
                      responseOutput.flush();
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.LOGOUT :
                    try {
                      System.out.println("case LOGOUT - 1");
                      listener.logout();
                      System.out.println("case LOGOUT - 2");
                    }
                    catch (PSEException ex) {
                      System.out.println("case LOGOUT - 3");
                      responseOutput.writeInt(PSEMessage.LOGOUT_FAILURE);
                      responseOutput.flush();
                      break;
                    }
                    try {
                      System.out.println("case LOGOUT - 4");
                      responseOutput.writeInt(PSEMessage.LOGOUT_SUCCESS);
                      System.out.println("case LOGOUT - 5");
                      responseOutput.flush();
                      break;
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.FIND_SERVICES_1 :
                    int brInd;
                    String servInt;
                    int wrapInd;
                    WrapperProfileJ2ME wrapProf;
                    String bridName;
                    FoundServicesProfiles fsProf = null;
                    try {
                      System.out.println("FIND_SERVICES_1 -1");
                      brInd = responseInput.readInt();
                      System.out.println("FIND_SERVICES_1 -2");
                      //servInt = (String)responseInput.readObject();
                      servInt = (String)responseInput.readUTF();
                      System.out.println("FIND_SERVICES_1 -3");
                      wrapInd = responseInput.readInt();
                      System.out.println("FIND_SERVICES_1 -4");
                      //wrapProf = (WrapperProfileJ2ME)responseInput.readObject();
                      wrapProf = (WrapperProfileJ2ME)WrapperProfileJ2ME.readFromStream(responseInput);
                      System.out.println("FIND_SERVICES_1 -5");
                      //bridName =(String)responseInput.readObject();
                      bridName =(String)responseInput.readUTF();
                    }
                    catch (Exception ex) {
                      responseOutput.writeInt(PSEMessage.ERROR);
                      responseOutput.flush();
                      System.out.println("FIND_SERVICES_1 -6");
                      break;
                    }
                    try {
                      System.out.println("FIND_SERVICES_1 -7");
                      fsProf = listener.findServices(brInd, servInt, wrapInd, wrapProf, bridName);
                      System.out.println("FIND_SERVICES_1 -8");
                    }
                    catch (PSEException ex) {
                      System.out.println("Ho ricevuto l'eccezione: "+ex.getMessage());
                      System.out.println("FIND_SERVICES_1 -9");
                      responseOutput.writeInt(PSEMessage.FIND_SERVICES_FAILURE);
                      responseOutput.flush();
                      System.out.println("FIND_SERVICES_1 -10");
                      break;
                    }
                    try {
                      System.out.println("FIND_SERVICES_1 -11");
                      responseOutput.writeInt(PSEMessage.FIND_SERVICES_SUCCESS);
                      System.out.println("FIND_SERVICES_1 -12");
                      //responseOutput.writeObject(fsProf);
                      FoundServicesProfiles.writeToStream(fsProf, responseOutput);
                      System.out.println("FIND_SERVICES_1 -13");
                      responseOutput.flush();
                      System.out.println("FIND_SERVICES_1 -14");
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.FIND_SERVICES_2 :
                    try {
                      System.out.println("FIND_SERVICES_2 -1");
                      brInd = responseInput.readInt();
                      System.out.println("FIND_SERVICES_1 -2");
                    }
                    catch (Exception ex) {
                      responseOutput.writeInt(PSEMessage.ERROR);
                      responseOutput.flush();
                      System.out.println("FIND_SERVICES_1 -6");
                      break;
                    }
                    try {
                      System.out.println("FIND_SERVICES_1 -7");
                      fsProf = listener.findServices(brInd);
                      System.out.println("FIND_SERVICES_1 -8 (verifica)");
                    }
                    catch (PSEException ex) {
                      System.out.println("Ho ricevuto l'eccezione: "+ex.getMessage());
                      System.out.println("FIND_SERVICES_1 -9");
                      responseOutput.writeInt(PSEMessage.FIND_SERVICES_FAILURE);
                      responseOutput.flush();
                      System.out.println("FIND_SERVICES_1 -10");
                      break;
                    }
                    try {
                      System.out.println("FIND_SERVICES_1 -11");
                      responseOutput.writeInt(PSEMessage.FIND_SERVICES_SUCCESS);
                      //responseOutput.writeObject(fsProf);
                      System.out.println("FIND_SERVICES_1 -12");
                      FoundServicesProfiles.writeToStream(fsProf, responseOutput);
                      System.out.println("FIND_SERVICES_1 -13");
                      responseOutput.flush();
                      System.out.println("FIND_SERVICES_1 -14");
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.START_BRIDGE :
                    int brPort;
                    int prInd;
                    try {
                      System.out.println("START_BRIDGE -1");
                      brInd = responseInput.readInt();
                      prInd = responseInput.readInt();
                    }
                    catch (Exception ex) {
                      responseOutput.writeInt(PSEMessage.ERROR);
                      responseOutput.flush();
                      break;
                    }
                    try {
                      //System.out.println("FIND_SERVICES_1 -7");
                      brPort = listener.startBridge(brInd, prInd);
                      //System.out.println("FIND_SERVICES_1 -8");
                    }
                    catch (PSEException ex) {
                      System.out.println("Ho ricevuto l'eccezione: "+ex.getMessage());
                      //System.out.println("FIND_SERVICES_1 -9");
                      responseOutput.writeInt(PSEMessage.START_BRIDGE_FAILURE);
                      responseOutput.flush();
                      //System.out.println("FIND_SERVICES_1 -10");
                      break;
                    }
                    try {
                      responseOutput.writeInt(PSEMessage.START_BRIDGE_SUCCESS);
                      responseOutput.writeInt(brPort);
                      responseOutput.flush();
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.STOP_BRIDGE :
                    try {
                      System.out.println("STOP_BRIDGE -1");
                      brInd = responseInput.readInt();
                    }
                    catch (Exception ex) {
                      responseOutput.writeInt(PSEMessage.ERROR);
                      responseOutput.flush();
                      break;
                    }
                    try {
                      //System.out.println("FIND_SERVICES_1 -7");
                      listener.stopBridge(brInd);
                      //System.out.println("FIND_SERVICES_1 -8");
                    }
                    catch (PSEException ex) {
                      System.out.println("Ho ricevuto l'eccezione: "+ex.getMessage());
                      System.out.println("STOP_BRIDGE -9");
                      responseOutput.writeInt(PSEMessage.STOP_BRIDGE_FAILURE);
                      responseOutput.flush();
                      //System.out.println("FIND_SERVICES_1 -10");
                      break;
                    }
                    try {
                      System.out.println("STOP_BRIDGE -10");
                      responseOutput.writeInt(PSEMessage.STOP_BRIDGE_SUCCESS);
                      responseOutput.flush();
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.STARTED_SERVICE :
                    try {
                      System.out.println("STARTED_SERVICE -1");
                      brInd = responseInput.readInt();
                    }
                    catch (Exception ex) {
                      responseOutput.writeInt(PSEMessage.ERROR);
                      responseOutput.flush();
                      break;
                    }
                    try {
                      //System.out.println("FIND_SERVICES_1 -7");
                      listener.startedService(brInd);
                      //System.out.println("FIND_SERVICES_1 -8");
                    }
                    catch (PSEException ex) {
                      System.out.println("Ho ricevuto l'eccezione: "+ex.getMessage());
                      //System.out.println("STOP_BRIDGE -9");
                      responseOutput.writeInt(PSEMessage.STARTED_SERVICE_FAILURE);
                      responseOutput.flush();
                      //System.out.println("FIND_SERVICES_1 -10");
                      break;
                    }
                    try {
                      //System.out.println("STOP_BRIDGE -10");
                      responseOutput.writeInt(PSEMessage.STARTED_SERVICE_SUCCESS);
                      responseOutput.flush();
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.STOPPED_SERVICE :
                    try {
                      System.out.println("STOPPED_SERVICE -1");
                      brInd = responseInput.readInt();
                    }
                    catch (Exception ex) {
                      responseOutput.writeInt(PSEMessage.ERROR);
                      responseOutput.flush();
                      break;
                    }
                    try {
                      //System.out.println("FIND_SERVICES_1 -7");
                      listener.stoppedService(brInd);
                      //System.out.println("FIND_SERVICES_1 -8");
                    }
                    catch (PSEException ex) {
                      System.out.println("Ho ricevuto l'eccezione: "+ex.getMessage());
                      //System.out.println("STOP_BRIDGE -9");
                      responseOutput.writeInt(PSEMessage.STOPPED_SERVICE_FAILURE);
                      responseOutput.flush();
                      //System.out.println("FIND_SERVICES_1 -10");
                      break;
                    }
                    try {
                      //System.out.println("STOP_BRIDGE -10");
                      responseOutput.writeInt(PSEMessage.STOPPED_SERVICE_SUCCESS);
                      responseOutput.flush();
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.GET_USER_PROFILE :
                    UserProfileJ2ME userProf;
                    System.out.println("GET_USER_PROFILE -1");
                    try {
                      //System.out.println("FIND_SERVICES_1 -7");
                      userProf = listener.getUserProfile();
                      //System.out.println("FIND_SERVICES_1 -8");
                    }
                    catch (PSEException ex) {
                      System.out.println("Ho ricevuto l'eccezione: "+ex.getMessage());
                      //System.out.println("STOP_BRIDGE -9");
                      responseOutput.writeInt(PSEMessage.GET_SERVICE_PREFERENCES_FAILURE);
                      responseOutput.flush();
                      //System.out.println("FIND_SERVICES_1 -10");
                      break;
                    }
                    try {
                      //System.out.println("STOP_BRIDGE -10");
                      responseOutput.writeInt(PSEMessage.GET_USER_PROFILE_SUCCESS);
                      //responseOutput.writeObject(userProf);
                      UserProfileJ2ME.writeToStream(userProf, responseOutput);
                      responseOutput.flush();
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.SET_USER_PROFILE :
                    try {
                      System.out.println("SET_USER_PROFILE -1");
                      //userProf = (UserProfileJ2ME)responseInput.readObject();
                      userProf = (UserProfileJ2ME)UserProfileJ2ME.readFromStream(responseInput);
                    }
                    catch (Exception ex) {
                      responseOutput.writeInt(PSEMessage.ERROR);
                      responseOutput.flush();
                      break;
                    }
                    try {
                      //System.out.println("FIND_SERVICES_1 -7");
                      listener.setUserProfile(userProf);
                      //System.out.println("FIND_SERVICES_1 -8");
                    }
                    catch (PSEException ex) {
                      System.out.println("Ho ricevuto l'eccezione: "+ex.getMessage());
                      //System.out.println("STOP_BRIDGE -9");
                      responseOutput.writeInt(PSEMessage.SET_USER_PROFILE_FAILURE);
                      responseOutput.flush();
                      //System.out.println("FIND_SERVICES_1 -10");
                      break;
                    }
                    try {
                      //System.out.println("STOP_BRIDGE -10");
                      responseOutput.writeInt(PSEMessage.SET_USER_PROFILE_SUCCESS);
                      responseOutput.flush();
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.GET_SERVICE_PREFERENCES :
                    ServicePreferencesJ2ME servPref;
                    try {
                      System.out.println("GET_SERVICE_PREFERENCES -1");
                      //servInt = (String)responseInput.readObject();
                      servInt = responseInput.readUTF();
                    }
                    catch (Exception ex) {
                      responseOutput.writeInt(PSEMessage.ERROR);
                      responseOutput.flush();
                      break;
                    }
                    try {
                      //System.out.println("FIND_SERVICES_1 -7");
                      servPref = listener.getServicePreferences(servInt);
                      //System.out.println("FIND_SERVICES_1 -8");
                    }
                    catch (PSEException ex) {
                      System.out.println("Ho ricevuto l'eccezione: "+ex.getMessage());
                      //System.out.println("STOP_BRIDGE -9");
                      responseOutput.writeInt(PSEMessage.GET_SERVICE_PREFERENCES_FAILURE);
                      responseOutput.flush();
                      //System.out.println("FIND_SERVICES_1 -10");
                      break;
                    }
                    try {
                      //System.out.println("STOP_BRIDGE -10");
                      responseOutput.writeInt(PSEMessage.GET_SERVICE_PREFERENCES_SUCCESS);
                      //responseOutput.writeObject(servPref);
                      ServicePreferencesJ2ME.writeToStream(servPref, responseOutput);
                      responseOutput.flush();
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.SET_SERVICE_PREFERENCES :
                    try {
                      System.out.println("SET_SERVICE_PREFERENCES -1");
                      //servPref = (ServicePreferencesJ2ME)responseInput.readObject();
                      servPref = (ServicePreferencesJ2ME)ServicePreferencesJ2ME.readFromStream(responseInput);
                    }
                    catch (Exception ex) {
                      responseOutput.writeInt(PSEMessage.ERROR);
                      responseOutput.flush();
                      break;
                    }
                    try {
                      //System.out.println("FIND_SERVICES_1 -7");
                      listener.setServicePreferences(servPref);
                      //System.out.println("FIND_SERVICES_1 -8");
                    }
                    catch (PSEException ex) {
                      System.out.println("Ho ricevuto l'eccezione: "+ex.getMessage());
                      //System.out.println("STOP_BRIDGE -9");
                      responseOutput.writeInt(PSEMessage.SET_SERVICE_PREFERENCES_FAILURE);
                      responseOutput.flush();
                      //System.out.println("FIND_SERVICES_1 -10");
                      break;
                    }
                    try {
                      //System.out.println("STOP_BRIDGE -10");
                      responseOutput.writeInt(PSEMessage.SET_SERVICE_PREFERENCES_SUCCESS);
                      responseOutput.flush();
                    }
                    catch (IOException ex) {
                      //Qua c' poco da fare...
                    }
                    break;
            case PSEMessage.DEVICE_ALIVE:
                    System.out.println("DEVICE_ALIVE -1");
                    listener.deviceAlive();
                    break;
            default: System.out.println("Messaggio non riconosciuto");
          }
        }
        catch (IOException exc) {
          //Per esempio errore nella comunicazione dell'errore. C' poco da fare...
          System.out.println("Errore grosso");
        }
      }
    }
  }
}