package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import javax.swing.*;
import java.awt.*;
import javax.swing.tree.*;

import pse.shared.*;
import javax.swing.event.*;
import java.rmi.RemoteException;

public class CacheModuleUI extends JPanel {

  private CacheModule cacheModule;
  private DefaultListModel servicesListModel = new DefaultListModel();

  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea logArea = new JTextArea();
  BorderLayout borderLayout2 = new BorderLayout();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JScrollPane jScrollPane2 = new JScrollPane();
  JList servicesList = new JList(servicesListModel);
  BorderLayout borderLayout4 = new BorderLayout();
  JPanel jPanel5 = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  JPanel jPanel6 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField serviceInterfaceTF = new JTextField();
  BorderLayout borderLayout6 = new BorderLayout();
  JLabel jLabel2 = new JLabel();
  JTree serviceProfileTree = new JTree(new DefaultTreeModel(new DefaultMutableTreeNode()));
  BorderLayout borderLayout7 = new BorderLayout();

  public CacheModuleUI(CacheModule cm) {
    cacheModule = cm;
    cacheModule.setUI(this);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  public CacheModuleUI() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    jPanel2.setLayout(borderLayout2);
    jPanel1.setLayout(borderLayout3);
    jPanel4.setLayout(borderLayout4);
    jPanel4.setPreferredSize(new Dimension(100, 132));
    jPanel3.setLayout(borderLayout5);
    jLabel1.setToolTipText("");
    jLabel1.setText("Interfaccia del servizio:");
    serviceInterfaceTF.setPreferredSize(new Dimension(150, 21));
    jPanel6.setLayout(borderLayout6);
    jLabel2.setText("Profilo del Servizio:");
    serviceProfileTree.setBorder(BorderFactory.createEtchedBorder());
    jPanel5.setLayout(borderLayout7);
    borderLayout7.setHgap(5);
    servicesList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        servicesList_valueChanged(e);
      }
    });
    jPanel2.setPreferredSize(new Dimension(4, 80));
    this.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(jPanel5, BorderLayout.NORTH);
    jPanel5.add(jLabel1, BorderLayout.WEST);
    jPanel5.add(serviceInterfaceTF, BorderLayout.CENTER);
    jPanel3.add(jPanel6, BorderLayout.CENTER);
    jPanel6.add(jLabel2, BorderLayout.NORTH);
    jPanel6.add(serviceProfileTree, BorderLayout.CENTER);
    jPanel1.add(jPanel4, BorderLayout.WEST);
    jPanel4.add(jScrollPane2, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(servicesList, null);
    this.add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(logArea, null);
  }

  public void serviceAdded(ServiceProxy serv) {
    System.out.println("CacheModule: Service appeared: " + serv);
    servicesListModel.addElement(serv);
  }

  public void serviceChanged(ServiceProxy newVers, ServiceProxy oldVers) {
    System.out.println("CacheModule: Service changed: " + newVers +" (era: "+oldVers);
    servicesListModel.removeElement(oldVers);
    servicesListModel.addElement(newVers);
  }

  public void serviceRemoved(ServiceProxy serv) {
    System.out.println("CacheModule: Service disappeared: " + serv);
    servicesListModel.removeElement(serv);
  }

  public void log(String msg) {
    logArea.append(msg+"\n");
    System.out.println(msg+"\n");
  }

  void servicesList_valueChanged(ListSelectionEvent e) {
    ServiceProxy asp = (ServiceProxy)servicesList.getSelectedValue();
    if (asp!=null) {
      String sInt = null;
      ServerProfile sProf = null;
      try {
        sInt = asp.getServiceInterface();
      } catch (RemoteException ex) {
          sInt = "Errore nella ricezione";
      }
      try {
        sProf = asp.getProfile();
      } catch (RemoteException ex) {
          sProf = new ServerProfile("Generato vuoto in seguito ad errore");
      }
      serviceInterfaceTF.setText(sInt);
      ProfileSectionNode root = new ProfileSectionNode(sProf);
      serviceProfileTree.setModel(new DefaultTreeModel(root));
    }
    /*
    SessionID sID = (SessionID)jListSessions.getSelectedValue();
    //sessionsListModel.getElementAt(index)
    SessionDescriptor sd = sessionModule.getSessionDescriptor(sID);
    userNameTF.setText(sd.getUserName());
    ClientProfileNode root = new ClientProfileNode(sd.getProfile());
    profileTree.setModel(new DefaultTreeModel(root));
    specProfileTree.setModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
    activeServicesCB.removeAllItems();
    Enumeration enas = sd.getActiveServiceIDs();
    while (enas.hasMoreElements()) {
      ServiceActivationID sAID = (ServiceActivationID)enas.nextElement();
      activeServicesCB.addItem(sAID);
    }
    */
  }
}