package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import javax.swing.*;
import java.awt.*;
import javax.swing.tree.*;

import pse.shared.*;
import javax.swing.event.*;

import java.util.Vector;

public class LoginModuleUI extends JPanel{

  private LoginModule loginModule;
  private DefaultListModel usersListModel = new DefaultListModel();

  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel4 = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  BorderLayout borderLayout4 = new BorderLayout();
  BorderLayout borderLayout5 = new BorderLayout();
  JTextArea logArea = new JTextArea();
  JScrollPane jScrollPane1 = new JScrollPane();
  JScrollPane jScrollPane2 = new JScrollPane();
  JTree profileTree = new JTree(new DefaultTreeModel(new DefaultMutableTreeNode()));
  JScrollPane jScrollPane3 = new JScrollPane();
  JList usersList = new JList(usersListModel);
  JPanel jPanel5 = new JPanel();
  JLabel jLabel1 = new JLabel();
  BorderLayout borderLayout6 = new BorderLayout();
  JComboBox sessionsComboBox = new JComboBox();

  public LoginModuleUI(LoginModule loginModule) {
    this.loginModule = loginModule;
    loginModule.setUI(this);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  public LoginModuleUI() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    this.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setLayout(borderLayout2);
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jPanel2.setLayout(borderLayout5);
    jPanel3.setLayout(borderLayout3);
    jPanel4.setLayout(borderLayout4);
    jScrollPane1.setPreferredSize(new Dimension(10, 80));
    jPanel4.setPreferredSize(new Dimension(100, 132));
    jLabel1.setText("Active Sessions:  ");
    jPanel5.setLayout(borderLayout6);
    usersList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        usersList_valueChanged(e);
      }
    });
    this.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(jScrollPane2, BorderLayout.CENTER);
    jPanel3.add(jPanel5, BorderLayout.NORTH);
    jPanel5.add(jLabel1, BorderLayout.WEST);
    jPanel5.add(sessionsComboBox, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(profileTree, null);
    jPanel1.add(jPanel4, BorderLayout.WEST);
    jPanel4.add(jScrollPane3, BorderLayout.CENTER);
    jScrollPane3.getViewport().add(usersList, null);
    this.add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(jScrollPane1, BorderLayout.NORTH);
    jScrollPane1.getViewport().add(logArea, null);
  }

  public void setUsers(/*lista degli utenti con i rispettivi profili*/) {
  }

  public void log(String msg) {
    logArea.setText(msg+"\n");
  }

  //ecc

  void foundUser(String userName) {
    usersListModel.addElement(userName);
  }
  void lostUser(String userName) {
    usersListModel.removeElement(userName);
  }
  void changedInfo(String userName) {
    Object selVal = usersList.getSelectedValue();
    if ((selVal!=null)&&(selVal.equals(userName))) {
      System.out.println("E' cambiato proprio quello che sto visualizzando");
      usersList_valueChanged(null);
    }
    else {
      System.out.println("Tes. Ne  cambiato un altro");
    }
  }

  void usersList_valueChanged(ListSelectionEvent e) {
    resetInfos();
    String user = (String)usersList.getSelectedValue();
    if (user!=null) {
      ClientProfile cp = loginModule.getClientProfile(user);
      if (cp!=null) {
        ClientProfileNode cpNode = new ClientProfileNode(cp);
        profileTree.setModel(new DefaultTreeModel(cpNode));
      }
      Vector sessions = loginModule.getActiveSessions(user);
      if (sessions!=null) {
        for (int i=0; i<sessions.size() ; i++) {
          sessionsComboBox.addItem(sessions.elementAt(i));
        }
      }
    }
  }

  private void resetInfos() {
    profileTree.setModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
    sessionsComboBox.removeAllItems();
  }
}