package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.shared.*;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

/**
 * Questa classe remota  quella che si occupa di garantire l'accesso al profilo del cliente
 * durante l'esecuizione del servizio, eventualmente da parte del server
 */
public class ProfileHandlerImpl extends UnicastRemoteObject implements RemoteProfileHandler {

  /**
   * SessionModule che contiene le informazioni riguardo alla sessione in esame del cliente
   */
  private SessionModule sessionModule;

  /**
   * @param sessionModule il SessionModule a cui fare riferimento
   */
  public ProfileHandlerImpl(SessionModule sessionModule) throws RemoteException {
    this.sessionModule = sessionModule;
  }

  /**
   * Restituisce il profilo del cliente relativo ad una determinata sessione di servizio
   * @sSID la sessione di servizio
   * @return il profilo del cliente relativo a quella sessione di servizio
   */
  public SpecificClientProfile getProfile(ServiceSessionID sSID) throws RemoteException {
    System.out.println("ProfileHandlerImpl.getProfile() con sSID = "+sSID);
    //Qui contatter il sessionModule....
    try {
      return sessionModule.getProfile(sSID);
    }
    catch (PSEException ex) {
      throw new RemoteException(ex.getMessage());
    }
  }
}