package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.server.*;
import pse.shared.*;
import pse.shared.framework.*;

import java.util.*;

 /**
  * Questa classe mantiene le informazioni associate ad una sessione:
  * lo userName dell'utente
  * il profilo completo dell'utente
  * i servizi attivi con il relativo profilo specifico del cliente
  */
public class SessionDescriptor {

  /** Nome dell'utente */
  private String userName;
  /** Profilo del cliente */
  private ClientProfile profile;
  /** Lista delle sessioni attive */
  private Hashtable activeServices; /*ServiceActivationID - il SpecificClientProfile*/
  //TODO: Eventualmente poi se serve associare alla sessione anche un'interfaccia di backcall per il server sul client

  public SessionDescriptor(String userName, ClientProfile profile) {
    this.userName = userName;
    this.profile = profile;
    activeServices = new  Hashtable();
  }

  public void setUserName(String userName) {
    this.userName = userName;
  }

  public String getUserName() {
    return userName;
  }

  public void setProfile(ClientProfile profile) {
    this.profile = profile;
  }

  public ClientProfile getProfile() {
    return profile;
  }

  public void serviceActivated(String serviceInterface, int ident, ServiceActivationID sAID) {
    //TODO: al posto del secondo parametro informazioni un po' migliori per reperire il profilo...
    activeServices.put(sAID, getProfileForService(serviceInterface, ident));
  }

  public void serviceDeactivated(ServiceActivationID sAID) {
    activeServices.remove(sAID);
  }

  public void updateProfile(WrapperProfile wp) {
    profile.addWrapperProfile(wp);
  }

  public SpecificClientProfile getProfile(String serviceInterface, int wrapperIndex) {
    return getProfileForService(serviceInterface, wrapperIndex);
  }

  public SpecificClientProfile getProfile(ServiceActivationID sAID) {
    return (SpecificClientProfile)activeServices.get(sAID);
  }

  public Enumeration getActiveServiceIDs() {
    return activeServices.keys();
  }

  public String toString() {
    return userName+" : "+profile;
  }

  private SpecificClientProfile getProfileForService(String serviceInterface, int wrapperIndex) {
    DeviceProfile dp = profile.getDeviceProfile();
    UserProfile up = profile.getUserProfile();
    ServicePreferences sp = profile.getServicePreferences(serviceInterface);
    WrapperProfile wp = profile.getWrapperProfile(serviceInterface, wrapperIndex);
    return new SpecificClientProfile("Costruto da SessionDescriptor", dp, up, sp, wp);
  }

}