package pse.shared;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.Serializable;

/**
 * Rappresenta una coppia valore-attributo all'interno di un ProfileSection
 */
public class ProfileAttribute implements Serializable {

  /**
   * Nome dell'attributo
   */
  private String name = null;
  /**
   * valore dell'attributo
   */
  private Object value = null;

  /*
  //UTILE ????
  public ProfileAttribute() {
  }*/

  /**
   * Costruttore
   * @param name il nome dell'attributo
   * @param value il valore dell'attributo
   */
  public ProfileAttribute(String name, Object value) {
    this.name = name;
    this.value = value;
  }

  /**
   * Costruttore. Il valore dell'attributo in questo caso  posto a null
   * @param name il nome dell'attributo
   */
  public ProfileAttribute(String name) {
    this.name = name;
  }

  /**
   * Test di attributo vuoto
   * @return true se il valore dell'attributo  posto a null
   */
  public boolean isNull() {
    return (value == null);
  }

  /**
   * Restituisce il valore dell'attributo
   * @return il valore dell'attributo (potrebbe anche essere null)
   */
  public Object getValue() {
    return value;
  }

  /**
   * Restituisce il nome dell'attributo
   * @return name
   */
  public String getName() {
    return name;
  }

  /**
   * Setta il valore dell'attributo
   * @param value il valore dell'attributo
   */
  public void setValue(Object value) {
    this.value = value;
  }

  /**
   * Setta il nome dell'attributo
   * @param name il nome dell'attributo
   */
  public void setName(String name) {
    this.name = name;
  }

  public String toString() {
    return "("+name+"="+value+")";
  }

}

