package pse.temp.client;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.client.*;
import pse.shared.*;
import pse.temp.shared.*;

import java.net.*;
import java.io.*;
import java.rmi.RemoteException;

public class Bridge implements ServiceBridge {

  private TempInterface proxy;
  private BridgeContext bridgeContext;

  ServerSocket ss;
  Socket socket;
  DataInputStream din;
  DataOutputStream dout;
  ServingThread servingThread;

  public Bridge() {
  }

  public int start(ServiceProxy pr, BridgeContext bc) throws PSEException {
    proxy = (TempInterface)pr;
    bridgeContext = bc;
    int port;
    try {
      ss = new ServerSocket(0);
      port = ss.getLocalPort();
      servingThread = new ServingThread();
      servingThread.start();
    }
    catch (Exception ex) {
      close();
      throw new PSEException("Error in starting bridge");
    }
    return port;
  }

  public void stop() {
    close();
  }

  private void close() {
    if (din!=null) {
      try {
        din.close();
      }
      catch (Exception ex) {
      }
    }
    if (dout != null) {
      try {
        dout.close();
      }
      catch (Exception ex) {
      }
    }
    if (ss!=null) {
      try {
        ss.close();
      }
      catch (Exception ex) {
      }
    }
    if (socket!=null) {
      try {
        socket.close();
      }
      catch (Exception ex) {
      }
    }
    if (servingThread != null) {
      servingThread.destroy();
    }
  }

  class ServingThread extends Thread {
    public void run() {
      try {
        socket = ss.accept();
        ss.close();
        din = new DataInputStream(socket.getInputStream());
        dout = new DataOutputStream(socket.getOutputStream());
      }
      catch (Exception ex) {
        System.out.println("Error in accepting connection");
      }
      System.out.println("Connection accepted");
      try {
        String rich = din.readUTF();
        System.out.println("Ho letto "+rich);
      }
      catch (Exception ex) {
        System.out.println("Error in reading request");
      }
      String res = null;
      try {
        res = proxy.execute();
      }
      catch (RemoteException ex) {
        System.out.println("Errore in Start : "+ex.getMessage());
      }
      try {
        dout.writeUTF(res);
      }
      catch (Exception ex) {
        System.out.println("Error in sending result to DClient");
      }
    }
    public void destroy() {
      //TODO
    }
  }

}