package pse.temp.client;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.client.*;
import pse.shared.*;
import pse.temp.shared.*;

import java.net.*;
import java.io.*;
import java.rmi.RemoteException;

public class Bridge3 implements ServiceBridge {

  private SboroneInterface proxy;
  private BridgeContext bridgeContext;

  ServerSocket ss;
  Socket socket;
  DataInputStream din;
  DataOutputStream dout;
  ServingThread servingThread;

  public Bridge3() {
  }

  public int start(ServiceProxy pr, BridgeContext bc) throws PSEException {
    proxy = (SboroneInterface)pr;
    bridgeContext = bc;
    int port;
    try {
      ss = new ServerSocket(0);
      port = ss.getLocalPort();
      servingThread = new ServingThread();
      servingThread.start();
    }
    catch (Exception ex) {
      close();
      throw new PSEException("Error in starting bridge");
    }
    return port;
  }

  public void stop() {
    close();
  }

  private void close() {
    if (din!=null) {
      try {
        din.close();
      }
      catch (Exception ex) {
      }
    }
    if (dout != null) {
      try {
        dout.close();
      }
      catch (Exception ex) {
      }
    }
    if (ss!=null) {
      try {
        ss.close();
      }
      catch (Exception ex) {
      }
    }
    if (socket!=null) {
      try {
        socket.close();
      }
      catch (Exception ex) {
      }
    }
    if (servingThread != null) {
      servingThread.destroy();
    }
  }

  class ServingThread extends Thread {
    boolean executing = true;
    public void run() {
      try {
        //System.out.println("Bridge3$ServingThread.run() -1");
        socket = ss.accept();
        //System.out.println("Bridge3$ServingThread.run() -2");
        ss.close();
        //System.out.println("Bridge3$ServingThread.run() -3");
        din = new DataInputStream(socket.getInputStream());
        //System.out.println("Bridge3$ServingThread.run() -4");
        dout = new DataOutputStream(socket.getOutputStream());
        //System.out.println("Bridge3$ServingThread.run() -5");
      }
      catch (Exception ex) {
        System.out.println("Error in accepting connection");
      }
      System.out.println("Connection accepted");
      //System.out.println("Bridge3$ServingThread.run() -6");
      while (executing) {
        int rich;
        //System.out.println("Bridge3$ServingThread.run() -7");
        try {
          //System.out.println("Bridge3$ServingThread.run() -8");
          rich = din.readInt();
          //System.out.println("Bridge3$ServingThread.run() -9");
          System.out.println("Ho letto "+rich);
          //System.out.println("Bridge3$ServingThread.run() -10");
          dout.writeInt(rich);
          //System.out.println("Bridge3$ServingThread.run() -11");
        }
        catch (Exception ex) {
          System.out.println("Error in reading or writing. Execution continues");
        }
      }
    }
    public void destroy() {
      executing = false;
    }
  }
}