package pse.temp.server;

import pse.temp.shared.*;

import net.jini.discovery.LookupDiscovery;
import net.jini.discovery.DiscoveryListener;
import net.jini.discovery.DiscoveryEvent;
import net.jini.core.lookup.ServiceRegistrar;
import net.jini.core.lookup.ServiceItem;
import net.jini.core.lookup.ServiceRegistration;
import net.jini.core.lease.Lease;
// import com.sun.jini.lease.LeaseRenewalManager;
// import com.sun.jini.lease.LeaseListener;
// import com.sun.jini.lease.LeaseRenewalEvent;
import net.jini.lease.LeaseRenewalManager;
import net.jini.lease.LeaseListener;
import net.jini.lease.LeaseRenewalEvent;
import java.rmi.RMISecurityManager;

import java.util.Vector;

/**
 * Title:
 * Description:  Step 1 della tesi
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class Server implements DiscoveryListener, LeaseListener {

  protected RemoteTempInterface impl;
  protected RemoteTempInterface impl2;
  protected RemoteSboroneInterface impl3;
  protected LeaseRenewalManager leaseManager = new LeaseRenewalManager();

  protected Vector leases = new Vector();

  public static void main(String argv[]) {
      new Server();

      // no need to keep server alive, RMI will do that
  }

  public Server() {
    try {
        impl = new TempInterfaceImpl();
        impl2 = new TempInterfaceImpl2();
        impl3 = new SboroneInterfaceImpl();
    } catch(Exception e) {
        System.err.println("New impl: " + e.toString());
        System.exit(1);
    }

    // install suitable security manager
    System.setSecurityManager(new RMISecurityManager());

    LookupDiscovery discover = null;
    try {
        discover = new LookupDiscovery(LookupDiscovery.ALL_GROUPS);
    } catch(Exception e) {
        System.err.println(e.toString());
        System.exit(1);
    }

    discover.addDiscoveryListener(this);

    Runtime.getRuntime().addShutdownHook(
      new Thread () {
        public void run() {
          System.out.println("Sono HOOK!");
          for (int i = 0; i<leases.size(); i++) {
            try {
              ((Lease)leases.elementAt(i)).cancel();
            }
            catch (Exception ex) {
              continue;
            }
          }
        }
      }
    );
  }

  public void discovered(DiscoveryEvent evt) {

      ServiceRegistrar[] registrars = evt.getRegistrars();
      //RemotePSEInterface service;

      for (int n = 0; n < registrars.length; n++) {
          ServiceRegistrar registrar = registrars[n];

          // export the proxy service
          ServiceItem item = new ServiceItem(null, impl, null);
          ServiceItem item2 = new ServiceItem(null, impl2, null);
          ServiceItem item3 = new ServiceItem(null, impl3, null);
          ServiceRegistration reg = null;
          ServiceRegistration reg2 = null;
          ServiceRegistration reg3 = null;
          try {
              reg = registrar.register(item, Lease.FOREVER);
              reg2 = registrar.register(item2, Lease.FOREVER);
              reg3 = registrar.register(item3, Lease.FOREVER);
          } catch(java.rmi.RemoteException e) {
              System.err.print("Register exception: "+e.getMessage());
              //e.printStackTrace();
              // System.exit(2);
              continue;
          }
          try {
              System.out.println("services registered at " +
                                 registrar.getLocator().getHost());
          } catch(Exception e) {
          }
          leases.add(reg.getLease());
          leases.add(reg2.getLease());
          leases.add(reg3.getLease());
          leaseManager.renewUntil(reg.getLease(), Lease.FOREVER, this);
          leaseManager.renewUntil(reg2.getLease(), Lease.FOREVER, this);
          leaseManager.renewUntil(reg3.getLease(), Lease.FOREVER, this);
      }
  }

    public void discarded(DiscoveryEvent evt) {

    }

    public void notify(LeaseRenewalEvent evt) {
	System.out.println("Lease expired " + evt.toString());
    }
}

